TranscodingStreams.jl
=====================

<!--[![Appveyor Status][appveyor-img]][appveyor-url]-->
[![Docs Stable][docs-stable-img]][docs-stable-url]
[![Docs Latest][docs-latest-img]][docs-latest-url]
[![Build Status](https://github.com/JuliaIO/TranscodingStreams.jl/actions/workflows/CI.yml/badge.svg?branch=master)](https://github.com/JuliaIO/TranscodingStreams.jl/actions/workflows/CI.yml?query=branch%3Amaster)
[![codecov.io][codecov-img]][codecov-url]

![TranscodingStream](/docs/src/assets/transcodingstream.png)

TranscodingStreams.jl is a package for transcoding data streams, which is:
- **fast**: small overhead and specialized methods,
- **consistent**: basic I/O operations you already know will work as you expect,
- **generic**: support any I/O objects like files, buffers, pipes, etc., and
- **extensible**: you can define a new codec to transcode data.

## Installation

```julia
Pkg.add("TranscodingStreams")
```

Installing a [codec package](#codec-packages) will install
TranscodingStreams.jl as well, and so in general you don't need to explicitly
install it.

## Usage

```julia
using TranscodingStreams, CodecZlib

# Some text.
text = """
Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean sollicitudin
mauris non nisi consectetur, a dapibus urna pretium. Vestibulum non posuere
erat. Donec luctus a turpis eget aliquet. Cras tristique iaculis ex, eu
malesuada sem interdum sed. Vestibulum ante ipsum primis in faucibus orci luctus
et ultrices posuere cubilia Curae; Etiam volutpat, risus nec gravida ultricies,
erat ex bibendum ipsum, sed varius ipsum ipsum vitae dui.
"""

# Streaming API.
stream = IOBuffer(text)
stream = TranscodingStream(GzipCompressor(), stream)
stream = TranscodingStream(GzipDecompressor(), stream)
for line in eachline(stream)
    println(line)
end
close(stream)

# Array API.
array = Vector{UInt8}(text)
array = transcode(GzipCompressor, array)
array = transcode(GzipDecompressor, array)
@assert text == String(array)

# Pre-allocated API
import TranscodingStreams: Buffer
compressed_buffer = Buffer(Vector{UInt8}(undef, ncodeunits(text)))
decompressed_buffer = Buffer(codeunits(text))
transcode(GzipCompressor, decompressed_buffer, compressed_buffer)
transcode(GzipDecompressor, compressed_buffer, decompressed_buffer)
@assert text == String(decompressed_buffer.data)
```

Each codec has an alias to its transcoding stream type for ease of use. For
example, `GzipCompressorStream{S} = TranscodingStream{GzipCompressor,S} where
S<:IO`.

Consult the [docs][docs-latest-url] for more details and examples.

## Codec packages

TranscodingStreams.jl offers I/O interfaces to users. It also offers a protocol
suite to communicate with various codecs. However, specific codecs are not
included in this package except the `Noop` codec, which does nothing to data.
The user need to install codecs as a plug-in to do something meaningful.

The following codec packages support the protocol suite:
- [CodecZlib.jl](https://github.com/JuliaIO/CodecZlib.jl)
- [CodecXz.jl](https://github.com/JuliaIO/CodecXz.jl)
- [CodecZstd.jl](https://github.com/JuliaIO/CodecZstd.jl)
- [CodecBase.jl](https://github.com/JuliaIO/CodecBase.jl)
- [CodecBzip2.jl](https://github.com/JuliaIO/CodecBzip2.jl)
- [CodecLz4.jl](https://github.com/JuliaIO/CodecLz4.jl) by Invenia.

[travisci-img]: https://travis-ci.org/JuliaIO/TranscodingStreams.jl.svg?branch=master
[travisci-url]: https://travis-ci.org/JuliaIO/TranscodingStreams.jl
[codecov-img]: http://codecov.io/github/JuliaIO/TranscodingStreams.jl/coverage.svg?branch=master
[codecov-url]: http://codecov.io/github/JuliaIO/TranscodingStreams.jl?branch=master
[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://juliaio.github.io/TranscodingStreams.jl/stable/
[docs-latest-img]: https://img.shields.io/badge/docs-latest-blue.svg
[docs-latest-url]: https://juliaio.github.io/TranscodingStreams.jl/latest/

using TranscodingStreams
using TestsForCodecPackages: TestsForCodecPackages
using Random
using Test
using Aqua: Aqua

Aqua.test_all(TranscodingStreams)
Aqua.test_all(TestsForCodecPackages)

@test isempty(detect_unbound_args(TranscodingStreams; recursive=true))
@test isempty(detect_ambiguities(TranscodingStreams; recursive=true))

# Tool tests
# ----------

using TranscodingStreams:
    Buffer, Memory,
    bufferptr, buffersize, buffermem,
    marginptr, marginsize, marginmem,
    readbyte!, writebyte!,
    #=ismarked,=# mark!, unmark!, reset!,
    makemargin!, initbuffer!

@testset "Buffer" begin
    buf = Buffer(1024)
    @test buf isa Buffer
    @test length(buf.data) == 1024

    data = Vector{UInt8}(b"foobar")
    buf = Buffer(data)
    GC.@preserve data buf begin
        @test buf isa Buffer
        @test bufferptr(buf) === pointer(data)
        @test buffersize(buf) === 6
        @test buffermem(buf) === Memory(pointer(data), 6)
        @test marginptr(buf) === pointer(data) + 6
        @test marginsize(buf) === 0
        @test marginmem(buf) === Memory(pointer(data)+6, 0)
    end

    buf = Buffer(2)
    writebyte!(buf, 0x34)
    writebyte!(buf, 0x9f)
    @test buffersize(buf) === 2
    @test readbyte!(buf) === 0x34
    @test readbyte!(buf) === 0x9f
    @test buffersize(buf) === 0

    buf = Buffer(16)
    @test !TranscodingStreams.ismarked(buf)
    @test mark!(buf) == 1
    @test TranscodingStreams.ismarked(buf)
    @test unmark!(buf)
    @test !TranscodingStreams.ismarked(buf)
    @test !unmark!(buf)

    buf = Buffer(16)
    mark!(buf)
    writebyte!(buf, 0x34)
    writebyte!(buf, 0x99)
    reset!(buf)
    @test !TranscodingStreams.ismarked(buf)
    @test readbyte!(buf) === 0x34
    @test readbyte!(buf) === 0x99

    buf = Buffer(16)
    @test makemargin!(buf, 0) === 16
    writebyte!(buf, 0x34)
    @test makemargin!(buf, 0) === 15
    writebyte!(buf, 0x99)
    margin_size = makemargin!(buf, 20) 
    @test margin_size >= 20
    initbuffer!(buf)
    @test makemargin!(buf, 0) === margin_size + 2
end

@testset "Memory" begin
    data = Vector{UInt8}(b"foobar")
    GC.@preserve data let mem = TranscodingStreams.Memory(pointer(data), sizeof(data))
        @test mem isa TranscodingStreams.Memory
        @test mem.ptr === pointer(data)
        @test mem.size === length(mem) === UInt(sizeof(data))
        @test lastindex(mem) === 6
        @test mem[1] === UInt8('f')
        @test mem[2] === UInt8('o')
        @test mem[3] === UInt8('o')
        @test mem[4] === UInt8('b')
        @test mem[5] === UInt8('a')
        @test mem[6] === UInt8('r')
        @test_throws BoundsError mem[7]
        @test_throws BoundsError mem[0]
        mem[1] = UInt8('z')
        @test mem[1] === UInt8('z')
        mem[3] = UInt8('!')
        @test mem[3] === UInt8('!')
        @test_throws BoundsError mem[7] = 0x00
        @test_throws BoundsError mem[0] = 0x00
    end

    data = Vector{UInt8}(b"foobar")
    GC.@preserve data let mem = TranscodingStreams.Memory(pointer(data), sizeof(data))
        @test mem isa TranscodingStreams.Memory
        @test mem.ptr == pointer(data)
        @test mem.size == sizeof(data)
    end
end

@testset "Stats" begin
    stats = TranscodingStreams.Stats(1,2,3,4)
    @test repr(stats) ==
    """
    TranscodingStreams.Stats:
      in: 1
      out: 2
      transcoded_in: 3
      transcoded_out: 4"""
    @test stats.in == 1
    @test stats.out == 2
    @test stats.transcoded_in == 3
    @test stats.transcoded_out == 4
end

@testset "Utils" begin
    @test TranscodingStreams.splitkwargs(
        [(:foo, 1), (:bar, true), (:baz, :ok)], (:foo,)) ==
        ([(:foo, 1)], [(:bar, true), (:baz, :ok)])
end


# Codec tests
# -----------

include("codecnoop.jl")
include("codecinvalid.jl")
include("codecquadruple.jl")
include("codecdoubleframe.jl")

# Transcoding State
# =================

# See docs/src/devnotes.md.
"""
A mutable state type of transcoding streams.

See Developer's notes for details.
"""
mutable struct State
    # current stream mode
    mode::Symbol  # {:idle, :read, :write, :stop, :close, :panic}

    # return code of the last method call
    code::Symbol  # {:ok, :end, :error}

    # flag to go :stop on :end while reading
    stop_on_end::Bool

    # exception thrown while data processing
    error::Error

    # data buffers
    buffer1::Buffer
    buffer2::Buffer

    # Number of bytes written to the underlying stream
    bytes_written_out::Int64

    function State(buffer1::Buffer, buffer2::Buffer)
        return new(:idle, :ok, false, Error(), buffer1, buffer2, Int64(0))
    end
end

function State(size::Integer)
    return State(Buffer(size), Buffer(size))
end

# An insane codec for testing the codec APIs.
struct QuadrupleCodec <: TranscodingStreams.Codec end

function TranscodingStreams.process(
        codec  :: QuadrupleCodec,
        input  :: TranscodingStreams.Memory,
        output :: TranscodingStreams.Memory,
        error  :: TranscodingStreams.Error)
    i = j = 0
    while i + 1 ≤ lastindex(input) && j + 4 ≤ lastindex(output)
        b = input[i+1]
        i += 1
        output[j+1] = output[j+2] = output[j+3] = output[j+4] = b
        j += 4
    end
    return i, j, input.size == 0 ? (:end) : (:ok)
end

function TranscodingStreams.expectedsize(
              :: QuadrupleCodec,
        input :: TranscodingStreams.Memory)
    return input.size * 4
end

function TranscodingStreams.minoutsize(
        :: QuadrupleCodec,
        :: TranscodingStreams.Memory)
    return 4
end

@testset "Quadruple Codec" begin
    @test transcode(QuadrupleCodec, b"") == b""
    @test transcode(QuadrupleCodec, b"a") == b"aaaa"
    @test transcode(QuadrupleCodec, b"ab") == b"aaaabbbb"
    @test transcode(QuadrupleCodec(), b"") == b""
    @test transcode(QuadrupleCodec(), b"a") == b"aaaa"
    @test transcode(QuadrupleCodec(), b"ab") == b"aaaabbbb"

    #=
    data = "x"^1024
    transcode(QuadrupleCodec(), data)
    @test (@allocated transcode(QuadrupleCodec(), data)) < sizeof(data) * 5
    =#

    stream = TranscodingStream(QuadrupleCodec(), NoopStream(IOBuffer("foo")))
    @test read(stream) == b"ffffoooooooo"
    close(stream)

    stream = NoopStream(TranscodingStream(QuadrupleCodec(), NoopStream(IOBuffer("foo"))))
    @test read(stream) == b"ffffoooooooo"
    close(stream)

    stream = TranscodingStream(QuadrupleCodec(), IOBuffer("foo"))
    @test position(stream) === Int64(0)
    read(stream, 3)
    @test position(stream) === Int64(3)
    read(stream, UInt8)
    @test position(stream) === Int64(4)
    close(stream)

    stream = TranscodingStream(QuadrupleCodec(), IOBuffer())
    @test position(stream) === Int64(0)
    write(stream, 0x00)
    @test position(stream) === Int64(1)
    write(stream, "foo")
    @test position(stream) === Int64(4)
    close(stream)

    # Buffers are shared.
    stream1 = TranscodingStream(QuadrupleCodec(), IOBuffer("foo"))
    stream2 = TranscodingStream(QuadrupleCodec(), stream1)
    @test stream1.buffer1 === stream2.buffer2
    close(stream1)
    close(stream2)

    # Explicitly unshare buffers.
    stream1 = TranscodingStream(QuadrupleCodec(), IOBuffer("foo"))
    stream2 = TranscodingStream(QuadrupleCodec(), stream1, sharedbuf=false)
    @test stream1.buffer1 !== stream2.buffer2
    close(stream1)
    close(stream2)

    stream = TranscodingStream(QuadrupleCodec(), IOBuffer("foo"))
    data = Vector{UInt8}(undef, 13)
    @test_throws EOFError GC.@preserve data unsafe_read(stream, pointer(data), 13)
    close(stream)

    @testset "position" begin
        iob = IOBuffer()
        sink = IOBuffer()
        stream = TranscodingStream(QuadrupleCodec(), sink, bufsize=16)
        @test position(stream) == position(iob)
        for len in 0:10:100
            write(stream, repeat("x", len))
            write(iob, repeat("x", len))
            @test position(stream) == position(iob)
        end
        close(stream)
        @test_throws ArgumentError position(stream)
        @test_throws ArgumentError TranscodingStreams.stats(stream)
        close(iob)

        mktemp() do path, sink
            stream = TranscodingStream(QuadrupleCodec(), sink, bufsize=16)
            pos = 0
            for len in 0:10:100
                write(stream, repeat("x", len))
                pos += len
                @test position(stream) == pos
            end
        end
    end

    @testset "skip" begin
        @testset "position" begin
            # make sure position is updated correctly by skip
            iob = IOBuffer(repeat("x", 400))
            source = IOBuffer(repeat("x", 100))
            stream = TranscodingStream(QuadrupleCodec(), source, bufsize=16)
            @test position(stream) == position(iob)
            for len in 0:10:100
                skip(stream, len)
                skip(iob, len)
                @test position(stream) == position(iob)
            end
            close(stream)
        end
        @testset "mark" begin
            iob = IOBuffer(repeat("x", 400))
            source = IOBuffer(repeat("x", 100))
            stream = TranscodingStream(QuadrupleCodec(), source, bufsize=16)
            @test position(stream) == position(iob)
            @test mark(stream) == mark(iob)
            for len in 0:10:100
                skip(stream, len)
                skip(iob, len)
                @test position(stream) == position(iob)
            end
            @test Base.reset(stream) == Base.reset(iob)
            for len in 0:10:100
                skip(stream, len)
                skip(iob, len)
                @test position(stream) == position(iob)
            end
            @test mark(stream) == mark(iob)
            @test Base.reset(stream) == Base.reset(iob)
            @test mark(stream) == mark(iob)
            close(stream)
            close(iob)
            @test !ismarked(stream)
            @test !ismarked(iob)
        end
    end

    @testset "seekstart" begin
        data = Vector(b"abracadabra")
        source = IOBuffer(data)
        seekend(source)
        stream = TranscodingStream(QuadrupleCodec(), source, bufsize=16)
        @test seekstart(stream) == stream
        @test position(stream) == 0
        @test read(stream, 5) == b"aaaab"
        @test position(stream) == 5
        @test seekstart(stream) == stream
        @test position(stream) == 0
        @test read(stream, 5) == b"aaaab"
        @test position(stream) == 5
    end

    @testset "seekstart doesn't delete data" begin
        for n in 0:3
            sink = IOBuffer()
            # wrap stream in NoopStream n times.
            stream = foldl(
                (s,_) -> NoopStream(s),
                1:n;
                init=TranscodingStream(QuadrupleCodec(), sink, bufsize=16)
            )
            write(stream, "x")
            # seekstart must not delete user data even if it errors.
            @test_throws ArgumentError seekstart(stream)
            write(stream, TranscodingStreams.TOKEN_END)
            flush(stream)
            @test take!(sink) == b"xxxx"
            close(stream)
        end
    end

    @testset "seekend doesn't delete data" begin
        for n in 0:3
            sink = IOBuffer()
            # wrap stream in NoopStream n times.
            stream = foldl(
                (s,_) -> NoopStream(s),
                1:n;
                init=TranscodingStream(QuadrupleCodec(), sink, bufsize=16)
            )
            write(stream, "x")
            # seekend must not delete user data even if it errors.
            @test_throws Exception seekend(stream)
            write(stream, TranscodingStreams.TOKEN_END)
            flush(stream)
            @test take!(sink) == b"xxxx"
            close(stream)
        end
    end

    @testset "eof throws ArgumentError after write" begin
        sink = IOBuffer()
        stream = TranscodingStream(QuadrupleCodec(), sink, bufsize=16)
        write(stream, "x")
        @test_throws ArgumentError eof(stream)
        @test_throws ArgumentError read(stream, UInt8)
        @test_throws ArgumentError eof(stream)
        write(stream, "y")
        @test_throws ArgumentError eof(stream)
        write(stream, TranscodingStreams.TOKEN_END)
        @test_throws ArgumentError eof(stream)
        flush(stream)
        @test_throws ArgumentError eof(stream)
        @test take!(sink) == b"xxxxyyyy"
        close(stream)
        @test_throws ArgumentError eof(stream)
    end
end

module TestsForCodecPackages

using Test: Test
using Random: seed!, randstring

using TranscodingStreams: TranscodingStreams, initialize, finalize, transcode, 
    TranscodingStream, NoopStream, TOKEN_END

TEST_RANDOM_SEED = 12345

export
    test_roundtrip_read,
    test_roundtrip_write,
    test_roundtrip_transcode,
    test_roundtrip_lines,
    test_roundtrip_seekstart,
    test_roundtrip_fileio,
    test_chunked_read,
    test_chunked_write

function test_roundtrip_read(encoder, decoder)
    seed!(TEST_RANDOM_SEED)
    for n in vcat(0:30, sort!(rand(500:100_000, 30))), alpha in (0x00:0xff, 0x00:0x0f)
        data = rand(alpha, n)
        file = IOBuffer(data)
        stream = decoder(encoder(file))
        Test.@test hash(read(stream)) == hash(data)
        close(stream)
    end
end

function test_roundtrip_write(encoder, decoder)
    seed!(TEST_RANDOM_SEED)
    for n in vcat(0:30, sort!(rand(500:100_000, 30))), alpha in (0x00:0xff, 0x00:0x0f)
        data = rand(alpha, n)
        sink = IOBuffer()
        decode_sink = decoder(sink)
        stream = encoder(decode_sink)
        write(stream, data)
        write(stream, TranscodingStreams.TOKEN_END)
        flush(stream)
        write(decode_sink, TranscodingStreams.TOKEN_END)
        flush(decode_sink)
        Test.@test take!(sink) == data
        close(stream)
    end
end

function test_roundtrip_transcode(encode, decode)
    seed!(TEST_RANDOM_SEED)
    encoder = encode()
    initialize(encoder)
    decoder = decode()
    initialize(decoder)
    for n in vcat(0:30, sort!(rand(500:100_000, 30))), alpha in (0x00:0xff, 0x00:0x0f)
        data = rand(alpha, n)
        Test.@test hash(transcode(decode, transcode(encode, data))) == hash(data)
        Test.@test hash(transcode(decoder, transcode(encoder, data))) == hash(data)
    end
    finalize(encoder)
    finalize(decoder)
end

function test_roundtrip_lines(encoder, decoder)
    seed!(TEST_RANDOM_SEED)
    lines = String[]
    buf = IOBuffer()
    stream = encoder(buf)
    for i in 1:100_000
        line = randstring(rand(0:1000))
        println(stream, line)
        push!(lines, line)
    end
    write(stream, TOKEN_END)
    flush(stream)
    seekstart(buf)
    Test.@test hash(lines) == hash(readlines(decoder(buf)))
end

function test_roundtrip_seekstart(encoder, decoder)
    seed!(TEST_RANDOM_SEED)
    for n in vcat(0:30, sort!(rand(500:100_000, 30))), alpha in (0x00:0xff, 0x00:0x0f)
        data = rand(alpha, n)
        file = IOBuffer(data)
        stream = decoder(encoder(file))
        for m in vcat(0:min(n,20), rand(0:n, 10))
            Test.@test read(stream, m) == @view(data[1:m])
            seekstart(stream)
        end
        seekstart(stream)
        Test.@test read(stream) == data
        seekstart(stream)
        Test.@test read(stream) == data
        close(stream)
    end
end

function test_roundtrip_fileio(Encoder, Decoder)
    data = b"""
    Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla sit amet tempus felis. Etiam molestie urna placerat iaculis pellentesque. Maecenas porttitor et dolor vitae posuere. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nunc eget nibh quam. Nullam aliquet interdum fringilla. Duis facilisis, lectus in consectetur varius, lorem sem tempor diam, nec auctor tellus nibh sit amet sapien. In ex nunc, elementum eget facilisis ut, luctus eu orci. Sed sapien urna, accumsan et elit non, auctor pretium massa. Phasellus consectetur nisi suscipit blandit aliquam. Nulla facilisi. Mauris pellentesque sem sit amet mi vestibulum eleifend. Nulla faucibus orci ac lorem efficitur, et blandit orci interdum. Aenean posuere ultrices ex sed rhoncus. Donec malesuada mollis sem, sed varius nunc sodales sed. Curabitur lobortis non justo non tristique.
    """
    mktemp() do filename, file
        stream = TranscodingStream(Encoder(), file)
        write(stream, data)
        close(stream)
        stream = TranscodingStream(Decoder(), open(filename))
        Test.@test hash(read(stream)) == hash(data)
        close(stream)
    end
end

function test_chunked_read(Encoder, Decoder)
    seed!(TEST_RANDOM_SEED)
    alpha = b"色即是空"
    encoder = Encoder()
    initialize(encoder)
    for sharedbuf in false:true
        for _ in 1:500
            chunks = [rand(alpha, rand(0:100)) for _ in 1:rand(1:100)]
            data = mapfoldl(x->transcode(encoder, x), vcat, chunks, init=UInt8[])
            buffer = NoopStream(IOBuffer(data))
            ok = true
            for chunk in chunks
                stream = TranscodingStream(Decoder(), buffer; stop_on_end=true, sharedbuf)
                ok &= read(stream) == chunk
                ok &= position(stream) == length(chunk)
                ok &= eof(stream)
                ok &= isreadable(stream)
                close(stream)
            end
            # read without stop_on_end should read the full data.
            stream = TranscodingStream(Decoder(), IOBuffer(data))
            ok &= read(stream) == reduce(vcat, chunks)
            close(stream)
            Test.@test ok
        end
    end
    finalize(encoder)
end

function test_chunked_write(Encoder, Decoder)
    seed!(TEST_RANDOM_SEED)
    alpha = b"空即是色"
    encoder = Encoder()
    initialize(encoder)
    for _ in 1:500
        chunks = [rand(alpha, rand(0:100)) for _ in 1:2]
        data = map(x->transcode(encoder, x), chunks)
        buffer = IOBuffer()
        stream = TranscodingStream(Decoder(), buffer, stop_on_end=true)
        write(stream, vcat(data...))
        close(stream)
        ok = true
        ok &= hash(take!(buffer)) == hash(vcat(chunks...))
        Test.@test ok
    end
    finalize(encoder)
end

end # module TestsForCodecPackages

using OffsetArrays: OffsetArray
using FillArrays: Zeros
using TestsForCodecPackages:
    test_roundtrip_read,
    test_roundtrip_write,
    test_roundtrip_transcode,
    test_roundtrip_lines,
    test_roundtrip_seekstart,
    test_roundtrip_fileio,
    test_chunked_read,
    test_chunked_write

@testset "Noop Codec" begin
    source = IOBuffer("")
    stream = TranscodingStream(Noop(), source)
    @test eof(stream)
    @inferred eof(stream)
    @test read(stream) == UInt8[]
    @test occursin("mode=read", repr(stream))

    source = IOBuffer("foo")
    stream = TranscodingStream(Noop(), source)
    @test !eof(stream)
    @test read(stream) == b"foo"
    close(stream)

    data = rand(UInt8, 100_000)
    source = IOBuffer(data)
    stream = TranscodingStream(Noop(), source)
    @test !eof(stream)
    @test read(stream) == data
    close(stream)

    stream = TranscodingStream(Noop(), IOBuffer())
    @test_throws EOFError read(stream, UInt8)
    data = Vector{UInt8}(undef, 3)
    @test_throws EOFError GC.@preserve data unsafe_read(stream, pointer(data), 3)
    close(stream)

    stream = TranscodingStream(Noop(), IOBuffer("foobar"), bufsize=1)
    @test read(stream, UInt8) === UInt8('f')
    data = Vector{UInt8}(undef, 5)
    GC.@preserve data unsafe_read(stream, pointer(data), 5) === nothing
    @test data == b"oobar"
    close(stream)

    sink = IOBuffer()
    stream = TranscodingStream(Noop(), sink)
    @test write(stream, "foo") === 3
    @test occursin("mode=write", repr(stream))
    flush(stream)
    @test take!(sink) == b"foo"
    close(stream)

    data = rand(UInt8, 100_000)
    sink = IOBuffer()
    stream = TranscodingStream(Noop(), sink)
    for i in 1:10_000
        @assert write(stream, data[10(i-1)+1:10i]) == 10
    end
    flush(stream)
    @test take!(sink) == data
    close(stream)

    stream = TranscodingStream(Noop(), IOBuffer(b"foobarbaz"))
    @test position(stream) === Int64(0)
    read(stream, UInt8)
    @test position(stream) === Int64(1)
    read(stream)
    @test position(stream) === Int64(9)

    data = collect(0x00:0x0f)
    stream = TranscodingStream(Noop(), IOBuffer(data))
    @test !ismarked(stream)
    @test mark(stream) == 0
    @test ismarked(stream)
    @test [read(stream, UInt8) for _ in 1:3] == data[1:3]
    @test reset(stream) == 0
    @test_throws ArgumentError reset(stream)
    @test !ismarked(stream)
    @test [read(stream, UInt8) for _ in 1:3] == data[1:3]
    @test mark(stream) == 3
    @test ismarked(stream)
    @test unmark(stream)
    @test !ismarked(stream)
    @test !unmark(stream)
    @test mark(stream) == 3
    close(stream)
    @test !ismarked(stream)

    stream = TranscodingStream(Noop(), IOBuffer(b"foobarbaz"))
    @test stream == seek(stream, 2)
    @test read(stream, 3) == b"oba"
    seek(stream, 0)
    @test read(stream, 3) == b"foo"
    @test stream == seekstart(stream)
    @test read(stream, 3) == b"foo"
    @test stream == seekend(stream)
    @test eof(stream)
    close(stream)

    data = collect(0x00:0x0f)
    stream = TranscodingStream(Noop(), IOBuffer(data))
    @test read(stream, UInt8) == data[1]
    skip(stream, 1)
    @test read(stream, UInt8) == data[3]
    skip(stream, 5)
    @test read(stream, UInt8) == data[9]
    skip(stream, 7)
    @test eof(stream)
    close(stream)

    # skip offset > bufsize
    data = collect(0x00:0x0f)
    stream = TranscodingStream(Noop(), IOBuffer(data), bufsize=2)
    @test read(stream, UInt8) == data[1]
    @test stream == skip(stream, 4)
    @test read(stream, UInt8) == data[6]
    skip(stream, 3)
    @test read(stream, UInt8) == data[10]
    skip(stream, 6)
    @test eof(stream)
    close(stream)

    stream = TranscodingStream(Noop(), IOBuffer("foo"))
    read(stream, UInt8)
    @test_throws ArgumentError skip(stream, -1)
    skip(stream, 100)
    @test eof(stream)
    close(stream)

    stream = TranscodingStream(Noop(), IOBuffer("foo"))
    out = zeros(UInt8, 3)
    @test bytesavailable(stream) == 0
    @test GC.@preserve out TranscodingStreams.unsafe_read(stream, pointer(out), 10) == 3
    @test out == b"foo"
    close(stream)

    data = rand(UInt8, 1999)
    # unmarked
    stream = TranscodingStream(Noop(), IOBuffer(data), bufsize=7)
    @test hash(read(stream)) == hash(data)
    @test length(stream.buffer1.data) == 7
    # marked
    stream = TranscodingStream(Noop(), IOBuffer(data), bufsize=7)
    mark(stream)
    @test hash(read(stream)) == hash(data)
    @test hash(stream.buffer1.data[1:length(data)]) == hash(data)
    close(stream)

    stream = NoopStream(NoopStream(IOBuffer("foobar")))
    @test read(stream) == b"foobar"
    close(stream)

    stream = NoopStream(NoopStream(NoopStream(IOBuffer("foobar"))))
    @test read(stream) == b"foobar"
    close(stream)

    stream = NoopStream(NoopStream(IOBuffer("foobar")); sharedbuf=false)
    @test read(stream) == b"foobar"
    close(stream)

    stream = NoopStream(NoopStream(IOBuffer("foobar")); sharedbuf=false)
    @test map(x->read(stream, UInt8), 1:6) == b"foobar"
    @test eof(stream)
    close(stream)

    stream = NoopStream(NoopStream(NoopStream(IOBuffer("foobar")); sharedbuf=false))
    @test read(stream) == b"foobar"
    close(stream)

    # Two buffers are the same object.
    stream = NoopStream(IOBuffer("foo"))
    @test stream.buffer1 === stream.buffer2

    # Nested NoopStreams share the same buffer.
    s0 = IOBuffer("foo")
    s1 = NoopStream(s0)
    s2 = NoopStream(s1)
    s3 = NoopStream(s2)
    @test s1.buffer1 === s2.buffer1 === s3.buffer1 ===
          s1.buffer2 === s2.buffer2 === s3.buffer2

    @testset "stats" begin
        stream = TranscodingStream(Noop(), IOBuffer(b"foobar"))
        stat = TranscodingStreams.stats(stream)
        @test stat.in === Int64(0)
        @test stat.out === Int64(0)
        eof(stream)
        stat = TranscodingStreams.stats(stream)
        @test stat.in === Int64(6)
        @test stat.out === Int64(0)
        read(stream)
        stat = TranscodingStreams.stats(stream)
        @test stat.in === Int64(6)
        @test stat.out === Int64(6)
        close(stream)

        #nested NoopStreams
        stream = NoopStream(NoopStream(IOBuffer(b"foobar")))
        stat = TranscodingStreams.stats(stream)
        @test stat.in === Int64(0)
        @test stat.out === Int64(0)
        eof(stream)
        stat = TranscodingStreams.stats(stream)
        @test stat.in === Int64(0)
        @test stat.out === Int64(0)
        read(stream)
        stat = TranscodingStreams.stats(stream)
        @test stat.in === Int64(6)
        @test stat.out === Int64(6)
        close(stream)

        stream = TranscodingStream(Noop(), IOBuffer())
        stat = TranscodingStreams.stats(stream)
        @test stat.in === Int64(0)
        @test stat.out === Int64(0)
        write(stream, b"foobar")
        stat = TranscodingStreams.stats(stream)
        @test stat.in === Int64(6)
        @test stat.out === Int64(0)
        flush(stream)
        stat = TranscodingStreams.stats(stream)
        @test stat.in === Int64(6)
        @test stat.out === Int64(6)
        close(stream)

        #nested NoopStreams
        stream = NoopStream(NoopStream(IOBuffer()))
        stat = TranscodingStreams.stats(stream)
        @test stat.in === Int64(0)
        @test stat.out === Int64(0)
        write(stream, b"foobar")
        stat = TranscodingStreams.stats(stream)
        @test stat.in === Int64(6)
        @test stat.out === Int64(6)
        flush(stream)
        stat = TranscodingStreams.stats(stream)
        @test stat.in === Int64(6)
        @test stat.out === Int64(6)
        close(stream)
    end

    stream = TranscodingStream(Noop(), IOBuffer())
    @test stream.state.mode == :idle
    @test write(stream) == 0
    @test stream.state.mode == :write
    close(stream)

    stream = NoopStream(IOBuffer("foobar"))
    @test bytesavailable(stream) === 0
    @test readavailable(stream) == b""
    @test read(stream, UInt8) === UInt8('f')
    @test bytesavailable(stream) === 5
    @test readavailable(stream) == b"oobar"
    close(stream)

    # issue #193
    stream = NoopStream(IOBuffer("foobar"))
    data = UInt8[]
    @test readbytes!(stream, data, 1) === 1
    @test data == b"f"
    @test position(stream) == 1
    close(stream)

    data = b""
    @test transcode(Noop, data)  == data
    @test transcode(Noop, data) !== data
    data = b"foo"
    @test transcode(Noop, data)  == data
    @test transcode(Noop, data) !== data

    data = UInt8[]
    @test TranscodingStreams.unsafe_transcode!(Noop(), data, data) == data
    data = [0x01, 0x02]
    @test_throws ErrorException transcode(Noop(), data, data)
    data = b""
    @test transcode(Noop(), data)  == data
    @test transcode(Noop(), data) !== data
    @test transcode(Noop(), data, Vector{UInt8}()) == data
    @test transcode(Noop(), data, TranscodingStreams.Buffer(Vector{UInt8}())) == data
    @test transcode(Noop(), data, Vector{UInt8}()) !== data
    @test transcode(Noop(), data, TranscodingStreams.Buffer(Vector{UInt8}())) !== data
    output = Vector{UInt8}()
    @test transcode(Noop(), data, output) === output
    output = TranscodingStreams.Buffer(Vector{UInt8}())
    @test transcode(Noop(), data, output) === output.data

    data = b"foo"
    @test transcode(Noop(), data)  == data
    @test transcode(Noop(), data) !== data
    @test transcode(Noop(), data, Vector{UInt8}()) == data
    @test transcode(Noop(), data, TranscodingStreams.Buffer(Vector{UInt8}())) == data
    @test transcode(Noop(), data, Vector{UInt8}()) !== data
    @test transcode(Noop(), data, TranscodingStreams.Buffer(Vector{UInt8}())) !== data
    output = Vector{UInt8}()
    @test transcode(Noop(), data, output) === output
    output = TranscodingStreams.Buffer(Vector{UInt8}())
    @test transcode(Noop(), data, output) === output.data

    data = ""
    @test String(transcode(Noop, data)) == data
    data = "foo"
    @test String(transcode(Noop, data)) == data

    test_roundtrip_transcode(Noop, Noop)
    test_roundtrip_read(NoopStream, NoopStream)
    test_roundtrip_write(NoopStream, NoopStream)
    test_roundtrip_lines(NoopStream, NoopStream)
    test_roundtrip_seekstart(NoopStream, NoopStream)

    @testset "switch write => read" begin
        stream = NoopStream(IOBuffer(collect(b"foobar"), read=true, write=true))
        @test isreadable(stream)
        @test iswritable(stream)
        @test_throws ArgumentError begin
            write(stream, b"xyz")
            read(stream, 3)
        end
        @test !isreadable(stream)
        @test iswritable(stream)
    end

    @testset "switch read => write" begin
        stream = NoopStream(IOBuffer(collect(b"foobar"), read=true, write=true))
        @test_throws ArgumentError begin
            read(stream, 3)
            write(stream, b"xyz")
        end
        @test isreadable(stream)
        @test !iswritable(stream)
    end

    @testset "unread" begin
        stream = NoopStream(IOBuffer(""))
        @test TranscodingStreams.unread(stream, b"foo") === nothing
        @test position(stream) == -3
        @test read(stream, 3) == b"foo"
        @test position(stream) == 0
        @test eof(stream)
        close(stream)

        stream = NoopStream(IOBuffer("foo"))
        @test read(stream, 3) == b"foo"
        @test position(stream) == 3
        @test TranscodingStreams.unread(stream, b"bar") === nothing
        @test position(stream) == 0
        @test read(stream, 3) == b"bar"
        @test position(stream) == 3
        @test eof(stream)
        close(stream)

        stream = NoopStream(IOBuffer("foobar"))
        @test TranscodingStreams.unread(stream, b"baz") === nothing
        @test read(stream, 3) == b"baz"
        @test read(stream, 3) == b"foo"
        @test read(stream, 3) == b"bar"
        @test eof(stream)
        close(stream)

        stream = NoopStream(IOBuffer("foobar"))
        @test read(stream, 3) == b"foo"
        @test TranscodingStreams.unread(stream, b"baz") === nothing
        @test read(stream, 3) == b"baz"
        @test read(stream, 3) == b"bar"
        @test eof(stream)
        close(stream)

        stream = NoopStream(IOBuffer("foobar"))
        @test position(stream) == 0
        @test read(stream, 3) == b"foo"
        @test position(stream) == 3
        @test read(stream, 3) == b"bar"
        @test position(stream) == 6
        @test TranscodingStreams.unread(stream, b"baz") === nothing
        @test position(stream) == 3
        @test read(stream, 3) == b"baz"
        @test position(stream) == 6
        @test eof(stream)
        @test position(stream) == 6
        close(stream)

        for bufsize in (1, 2, 3, 4, 100)
            for n in (1, 100)
                stream = NoopStream(IOBuffer("foo"^n*"bar"^n); bufsize)
                @test mark(stream) == 0
                @test position(stream) == 0
                @test read(stream, 3n) == codeunits("foo"^n)
                @test read(stream, 3n) == codeunits("bar"^n)
                @test position(stream) == 6n
                TranscodingStreams.unread(stream, codeunits("baz"^n))
                @test position(stream) == 3n
                @test reset(stream) == 0
                @test position(stream) == 0
                @test read(stream, 3n) == codeunits("foo"^n)
                @test read(stream, 3n) == codeunits("baz"^n)
                @test position(stream) == 6n
                @test eof(stream)
                @test position(stream) == 6n
                close(stream)
            end
        end

        # unread before mark
        stream = NoopStream(IOBuffer("foobar"); bufsize=16)
        @test read(stream, String) == "foobar"
        mark(stream)
        for i in 1:100
            TranscodingStreams.unread(stream, b"foo")
        end
        @test read(stream, String) == "foo"^100
        @test reset(stream) == 6
        @test eof(stream)

        stream = NoopStream(IOBuffer("foobar"))
        data = b"foo"
        @test_throws ArgumentError GC.@preserve data TranscodingStreams.unsafe_unread(stream, pointer(data), -1)
        close(stream)

        stream = NoopStream(IOBuffer("foo"))
        @test read(stream, 3) == b"foo"
        @test TranscodingStreams.unread(stream, OffsetArray(b"bar", -5:-3)) === nothing
        @test read(stream, 3) == b"bar"
        close(stream)

        stream = NoopStream(IOBuffer("foobar"))
        @test read(stream, 3) == b"foo"
        @test_throws OverflowError TranscodingStreams.unread(stream, Zeros{UInt8}(typemax(Int))) === nothing
        close(stream)

        stream = NoopStream(IOBuffer("foo"))
        @test read(stream, 3) == b"foo"
        @test TranscodingStreams.unread(stream, Zeros{UInt8}(big(3))) === nothing
        @test read(stream, 3) == b"\0\0\0"
        close(stream)

        stream = NoopStream(IOBuffer("foo"))
        @test read(stream, 3) == b"foo"
        d = b"bar"
        GC.@preserve d begin
            @test TranscodingStreams.unsafe_unread(stream, pointer(d), 3) === nothing
        end
        @test read(stream, 3) == b"bar"
        close(stream)

        stream = NoopStream(IOBuffer())
        write(stream, b"foo")
        @test_throws ArgumentError TranscodingStreams.unread(stream, b"bar")
        close(stream)
    end

    stream = NoopStream(IOBuffer(""))
    unsafe_write(stream, C_NULL, 0)
    @test_throws ArgumentError eof(stream)  # write
    close(stream)
    @test_throws ArgumentError eof(stream)  # close

    @testset "readuntil" begin
        stream = NoopStream(IOBuffer(""))
        data = readuntil(stream, 0x00)
        @test data isa Vector{UInt8}
        @test isempty(data)

        stream = NoopStream(IOBuffer("foo,bar"))
        @test readuntil(stream, UInt8(',')) == b"foo"
        @test read(stream) == b"bar"

        stream = NoopStream(IOBuffer("foo,bar"))
        @test readuntil(stream, UInt8(','), keep = false) == b"foo"
        @test read(stream) == b"bar"

        stream = NoopStream(IOBuffer("foo,bar"))
        @test readuntil(stream, UInt8(','), keep = true) == b"foo,"
        @test read(stream) == b"bar"
    end

    @test_throws ArgumentError NoopStream(IOBuffer(), bufsize=0)
    @test_throws ArgumentError NoopStream(let s = IOBuffer(); close(s); s; end)
    @test_throws ArgumentError TranscodingStream(Noop(), IOBuffer(), bufsize=0)
    @test_throws ArgumentError TranscodingStream(Noop(), IOBuffer(), sharedbuf=true)

    @testset "position" begin
        iob = IOBuffer()
        sink = IOBuffer()
        stream = NoopStream(sink, bufsize=16)
        @test position(stream) == position(iob)
        for len in 0:10:100
            write(stream, repeat("x", len))
            write(iob, repeat("x", len))
            @test position(stream) == position(iob)
        end
        @test position(stream) == position(sink) == position(iob)
        close(stream)
        @test_throws ArgumentError position(stream)
        @test_throws ArgumentError TranscodingStreams.stats(stream)
        close(iob)

        mktemp() do path, sink
            stream = NoopStream(sink, bufsize=16)
            pos = 0
            for len in 0:10:100
                write(stream, repeat("x", len))
                pos += len
                @test position(stream) == pos
            end
        end

        @testset "writing nested NoopStream sharedbuf=$(sharedbuf)" for sharedbuf in (true, false)
            stream = NoopStream(NoopStream(IOBuffer()); sharedbuf, bufsize=4)
            @test position(stream) == 0
            write(stream, 0x01)
            @test position(stream) == 1
            flush(stream)
            @test position(stream) == 1
            write(stream, "abc")
            @test position(stream) == 4
            flush(stream)
            @test position(stream) == 4
            for i in 1:10
                write(stream, 0x01)
                @test position(stream) == 4 + i
            end
        end

        @testset "reading nested NoopStream sharedbuf=$(sharedbuf)" for sharedbuf in (true, false)
            stream = NoopStream(NoopStream(IOBuffer("abcdefghijk")); sharedbuf, bufsize=4)
            @test position(stream) == 0
            @test !eof(stream)
            @test position(stream) == 0
            @test read(stream, UInt8) == b"a"[1]
            @test position(stream) == 1
            @test read(stream, 3) == b"bcd"
            @test position(stream) == 4
            @test !eof(stream)
            @test position(stream) == 4
            @test read(stream) == b"efghijk"
            @test position(stream) == 11
            @test eof(stream)
            @test position(stream) == 11
        end

    end

    @testset "seek doesn't delete data" begin
        sink = IOBuffer()
        stream = NoopStream(sink, bufsize=16)
        write(stream, "x")
        seekstart(stream)
        flush(stream)
        @test take!(sink) == b"x"
        close(stream)

        op_expected = [
            (seekstart, b"dbc"),
            (seekend, b"abcd"),
            (Base.Fix2(seek, 1), b"adc"),
        ]
        @testset "$op" for (op, expected) in op_expected
            sink = IOBuffer()
            stream = NoopStream(sink, bufsize=16)
            write(stream, "abc")
            @test op(stream) === stream
            write(stream, "d")
            flush(stream)
            @test take!(sink) == expected
            close(stream)
        end
    end

    @testset "stop_on_end=true prevents underlying stream closing" begin
        sink = IOBuffer()
        stream = NoopStream(sink, stop_on_end=true)
        write(stream, "abcd")
        close(stream)
        @test isopen(sink)
        @test take!(sink) == b"abcd"
    end

    @testset "peek" begin
        stream = NoopStream(IOBuffer(codeunits("こんにちは")))
        @test peek(stream) == 0xe3
        @test peek(stream, Char) == 'こ'
        @test peek(stream, Int32) == -476872221
        close(stream)
    end

end

# Transcoding Stream
# ==================

# Data Flow
# ---------
#
# When reading data (`state.mode == :read`):
#   user <--- |state.buffer1| <--- <codec> <--- |state.buffer2| <--- stream
#
# When writing data (`state.mode == :write`):
#   user ---> |state.buffer1| ---> <codec> ---> |state.buffer2| ---> stream

struct TranscodingStream{C<:Codec,S<:IO} <: IO
    # codec object
    codec::C

    # source/sink stream
    stream::S

    # mutable state of the stream
    state::State

    # data buffers
    buffer1::Buffer
    buffer2::Buffer

    function TranscodingStream{C,S}(
            codec::C, stream::S, state::State, initialized::Bool) where {C<:Codec,S<:IO}
        if !isopen(stream)
            throw(ArgumentError("closed stream"))
        elseif state.mode != :idle
            throw(ArgumentError("invalid initial mode"))
        end
        if !initialized
            initialize(codec)
        end
        return new(codec, stream, state, state.buffer1, state.buffer2)
    end
end

function TranscodingStream(codec::C, stream::S, state::State;
                           initialized::Bool=false) where {C<:Codec,S<:IO}
    return TranscodingStream{C,S}(codec, stream, state, initialized)
end

const DEFAULT_BUFFER_SIZE = 16 * 2^10  # 16KiB

function checkbufsize(bufsize::Integer)
    if bufsize ≤ 0
        throw(ArgumentError("non-positive buffer size"))
    end
end

function checksharedbuf(sharedbuf::Bool, stream::IO)
    if sharedbuf && !(stream isa TranscodingStream)
        throw(ArgumentError("invalid stream type for sharedbuf=true"))
    end
end

"""
    TranscodingStream(codec::Codec, stream::IO;
                      bufsize::Integer=$(DEFAULT_BUFFER_SIZE),
                      stop_on_end::Bool=false,
                      sharedbuf::Bool=(stream isa TranscodingStream))

Create a transcoding stream with `codec` and `stream`.

A `TranscodingStream` object wraps an input/output stream object `stream`, and
transcodes the byte stream using `codec`. It is a subtype of `IO` and supports
most of the I/O functions in the standard library.

See the docs (<https://bicycle1885.github.io/TranscodingStreams.jl/stable/>) for
available codecs, examples, and more details of the type.

Arguments
---------

- `codec`:
    The data transcoder. The transcoding stream does the initialization and
    finalization of `codec`. Therefore, a codec object is not reusable once it
    is passed to a transcoding stream.
- `stream`:
    The wrapped stream. It must be opened before passed to the constructor.
- `bufsize`:
    The initial buffer size (the default size is 16KiB). The buffer may be
    extended whenever `codec` requests so.
- `stop_on_end`:
    The flag to stop reading on `:end` return code from `codec`.  The
    transcoded data are readable even after stopping transcoding process.  With
    this flag on, `stream` is not closed when the wrapper stream is closed with
    `close`.  Note that if reading some extra data may be read from `stream` into an
    internal buffer, and thus `stream` must be a `TranscodingStream` object and
    `sharedbuf` must be `true` to reuse `stream`.
- `sharedbuf`:
    The flag to share buffers between adjacent transcoding streams.  The value
    must be `false` if `stream` is not a `TranscodingStream` object.

Examples
--------

```jldoctest
julia> using TranscodingStreams

julia> file = open(joinpath(dirname(dirname(pathof(TranscodingStreams))), "README.md"));

julia> stream = TranscodingStream(Noop(), file);

julia> readline(file)
"TranscodingStreams.jl"

julia> close(stream)
```
"""
function TranscodingStream(codec::Codec, stream::IO;
                           bufsize::Integer=DEFAULT_BUFFER_SIZE,
                           stop_on_end::Bool=false,
                           sharedbuf::Bool=(stream isa TranscodingStream))
    checkbufsize(bufsize)
    checksharedbuf(sharedbuf, stream)
    if sharedbuf
    	# Here, the compiler cannot infer at compile time that the
    	# stream must be a TranscodingStream, so we need to help the
    	# compiler along. See https://github.com/JuliaIO/TranscodingStreams.jl/pull/111
        stream::TranscodingStream
        state = State(Buffer(bufsize), stream.buffer1)
    else
        state = State(bufsize)
    end
    state.stop_on_end = stop_on_end
    return TranscodingStream(codec, stream, state)
end

function Base.show(io::IO, stream::TranscodingStream)
    print(io, summary(stream), "(<mode=$(stream.state.mode)>)")
end

# Split keyword arguments.
@nospecialize
@static if isdefined(Base, :Pairs)
splitkwargs(kwargs::Base.Pairs, ks::Tuple{Vararg{Symbol}}) = splitkwargs(NamedTuple(kwargs), ks)
end
function splitkwargs(kwargs::NamedTuple, ks::Tuple{Vararg{Symbol}})
    non_ks = Base.diff_names(keys(kwargs), ks)
    ks = Base.diff_names(keys(kwargs), non_ks)
    return NamedTuple{ks}(kwargs), NamedTuple{non_ks}(kwargs)
end
function splitkwargs(kwargs, keys)
    hits = []
    others = []
    for kwarg in kwargs
        push!(kwarg[1] ∈ keys ? hits : others, kwarg)
    end
    return hits, others
end
@specialize

# throw ArgumentError that mode is invalid.
throw_invalid_mode(mode) = throw(ArgumentError(string("invalid mode :", mode)))

# Return true if the stream shares buffers with underlying stream
function has_sharedbuf(stream::TranscodingStream)::Bool
    stream.stream isa TranscodingStream && stream.buffer2 === stream.stream.buffer1
end

# Base IO Functions
# -----------------

function Base.open(f::Function, ::Type{T}, args...) where T<:TranscodingStream
    stream = T(open(args...))
    try
        f(stream)
    finally
        close(stream)
    end
end

function Base.isopen(stream::TranscodingStream)
    return stream.state.mode != :close && stream.state.mode != :panic
end

function Base.isreadable(stream::TranscodingStream)::Bool
    mode = stream.state.mode
    (mode === :idle || mode === :read || mode === :stop) && isreadable(stream.stream)
end

function Base.iswritable(stream::TranscodingStream)::Bool
    mode = stream.state.mode
    (mode === :idle || mode === :write) && iswritable(stream.stream)
end

function Base.close(stream::TranscodingStream)
    mode = stream.state.mode
    try
        if mode != :panic
            changemode!(stream, :close)
        end
    finally
        if !stream.state.stop_on_end
            close(stream.stream)
        end
    end
    return nothing
end

function Base.eof(stream::TranscodingStream)
    eof = buffersize(stream.buffer1) == 0
    state = stream.state
    mode = state.mode
    if !(mode === :read || mode === :stop)
        changemode!(stream, :read)
    end
    if eof
        eof = sloweof(stream)
    end
    return eof
end
@noinline function sloweof(stream::TranscodingStream)
    state = stream.state
    mode = state.mode
    @assert mode == :read || mode == :stop
    if mode == :read
        return (buffersize(stream.buffer1) == 0 && fillbuffer(stream) == 0)
    elseif mode == :stop
        return buffersize(stream.buffer1) == 0
    end
    @assert false
end

function Base.ismarked(stream::TranscodingStream)::Bool
    checkmode(stream)
    isopen(stream) && ismarked(stream.buffer1)
end

function Base.mark(stream::TranscodingStream)::Int64
    ready_to_read!(stream)
    mark!(stream.buffer1)
    position(stream)
end

function Base.unmark(stream::TranscodingStream)::Bool
    checkmode(stream)
    isopen(stream) && unmark!(stream.buffer1)
end

function Base.reset(stream::T) where T<:TranscodingStream
    Base.ismarked(stream) || throw(ArgumentError("$T not marked"))
    reset!(stream.buffer1)
    position(stream)
end

"""
    position(stream::TranscodingStream)

Return the number of bytes read from or written to `stream`.

Note that the returned value will be different from that of the underlying
stream wrapped by `stream`.  This is because `stream` buffers some data and the
codec may change the length of data.
"""
function Base.position(stream::TranscodingStream)
    mode = stream.state.mode
    if mode === :idle
        return Int64(0)
    elseif mode === :read || mode === :stop
        return stats(stream).out
    elseif mode === :write
        return stats(stream).in
    else
        throw_invalid_mode(mode)
    end
    @assert false "unreachable"
end


# Seek Operations
# ---------------

function Base.seekstart(stream::TranscodingStream)
    mode = stream.state.mode
    if mode === :read
        callstartproc(stream, mode)
        initbuffer!(stream.buffer1)
        initbuffer!(stream.buffer2)
    elseif mode === :idle
    else
        throw_invalid_mode(mode)
    end
    seekstart(stream.stream)
    return stream
end


# Read Functions
# --------------

# needed for `peek(stream, Char)` to work
function Base.peek(stream::TranscodingStream, ::Type{UInt8})::UInt8
    if eof(stream)
        throw(EOFError())
    end
    buf = stream.buffer1
    return buf.data[buf.bufferpos]
end

function Base.read(stream::TranscodingStream, ::Type{UInt8})::UInt8
    x = peek(stream)
    consumed!(stream.buffer1, 1)
    x
end

function Base.readuntil(stream::TranscodingStream, delim::UInt8; keep::Bool=false)
    ready_to_read!(stream)
    buffer1 = stream.buffer1
    # delay initialization so as to reduce the number of buffer resizes
    local ret::Vector{UInt8}
    filled = 0
    while !eof(stream)
        GC.@preserve buffer1 begin
            p = findbyte(buffer1, delim)
            found = false
            if p < marginptr(buffer1)
                found = true
                sz = Int(p + 1 - bufferptr(buffer1))
                if !keep
                    sz -= 1
                end
            else
                sz = buffersize(buffer1)
            end
        end
        if @isdefined(ret)
            resize!(ret, filled + sz)
        else
            @assert filled == 0
            ret = Vector{UInt8}(undef, sz)
        end
        GC.@preserve ret copydata!(pointer(ret, filled+1), buffer1, sz)
        filled += sz
        if found
            if !keep
                # skip the delimiter
                skipbuffer!(buffer1, 1)
            end
            break
        end
    end
    if !@isdefined(ret)
        # special case: stream is empty
        ret = UInt8[]
    end
    return ret
end

"""
    skip(stream::TranscodingStream, offset)

Read bytes from `stream` until `offset` bytes have been read or `eof(stream)` is reached.

Return `stream`, discarding read bytes.

This function will not throw an `EOFError` if `eof(stream)` is reached before
`offset` bytes can be read.
"""
function Base.skip(stream::TranscodingStream, offset::Integer)
    if offset < 0
        # TODO support negative offset if stream is marked
        throw(ArgumentError("negative offset"))
    end
    ready_to_read!(stream)
    buffer1 = stream.buffer1
    skipped = 0
    while skipped < offset && !eof(stream)
        n = min(buffersize(buffer1), offset - skipped)
        skipbuffer!(buffer1, n)
        skipped += n
    end
    return stream
end

function Base.unsafe_read(stream::TranscodingStream, output::Ptr{UInt8}, nbytes::UInt)
    ready_to_read!(stream)
    buffer = stream.buffer1
    p = output
    p_end = output + nbytes
    while p < p_end && !eof(stream)
        m = min(buffersize(buffer), p_end - p)
        copydata!(p, buffer, m)
        p += m
        GC.safepoint()
    end
    if p < p_end
        throw(EOFError())
    end
    return
end

function Base.readbytes!(stream::TranscodingStream, b::DenseArray{UInt8}, nb=length(b))
    ready_to_read!(stream)
    filled = 0
    resized = false
    while filled < nb && !eof(stream)
        if length(b) == filled
            resize!(b, min(max(length(b) * 2, 8), nb))
            resized = true
        end
        filled += GC.@preserve b unsafe_read(stream, pointer(b, filled+firstindex(b)), min(length(b), nb)-filled)
    end
    if resized
        resize!(b, filled)
    end
    return filled
end

function Base.bytesavailable(stream::TranscodingStream)
    ready_to_read!(stream)
    return buffersize(stream.buffer1)
end

function Base.readavailable(stream::TranscodingStream)
    n = bytesavailable(stream)
    data = Vector{UInt8}(undef, n)
    GC.@preserve data unsafe_read(stream, pointer(data), n)
    return data
end

"""
    unread(stream::TranscodingStream, data::AbstractVector{UInt8})

Insert `data` to the current reading position of `stream`.

The next `read(stream, sizeof(data))` call will read data that are just
inserted.

`data` must not alias any internal buffers in `stream`
"""
function unread(stream::TranscodingStream, data::AbstractVector{UInt8})
    ready_to_read!(stream)
    insertdata!(stream.buffer1, data)
    return nothing
end

"""
    unsafe_unread(stream::TranscodingStream, data::Ptr, nbytes::Integer)

Insert `nbytes` pointed by `data` to the current reading position of `stream`.

The data are copied into the internal buffer and hence `data` can be safely used
after the operation without interfering the stream.

`data` must not alias any internal buffers in `stream`
"""
function unsafe_unread(stream::TranscodingStream, data::Ptr, nbytes::Integer)
    if nbytes < 0
        throw(ArgumentError("negative nbytes"))
    end
    ready_to_read!(stream)
    insertdata!(stream.buffer1, Memory(convert(Ptr{UInt8}, data), UInt(nbytes)))
    return nothing
end

# Ready to read data from the stream.
function ready_to_read!(stream::TranscodingStream)
    mode = stream.state.mode
    if !(mode == :read || mode == :stop)
        changemode!(stream, :read)
    end
    return
end


# Write Functions
# ---------------

# Write nothing.
function Base.write(stream::TranscodingStream)
    changemode!(stream, :write)
    return 0
end

function Base.write(stream::TranscodingStream, b::UInt8)::Int
    changemode!(stream, :write)
    buffer1 = stream.buffer1
    marginsize(buffer1) > 0 || flush_buffer1(stream)
    writebyte!(buffer1, b)
    return 1
end

function Base.unsafe_write(stream::TranscodingStream, input::Ptr{UInt8}, nbytes::UInt)
    changemode!(stream, :write)
    Int(nbytes) # Error if nbytes > typemax Int
    buffer1 = stream.buffer1
    p = input
    p_end = p + nbytes
    while p < p_end
        if marginsize(buffer1) ≤ 0
            flush_buffer1(stream)
        end
        m = min(marginsize(buffer1), p_end - p)
        copydata!(buffer1, p, m)
        p += m
        GC.safepoint()
    end
    return Int(p - input)
end

# A singleton type of end token.
struct EndToken end

"""
A special token indicating the end of data.

`TOKEN_END` may be written to a transcoding stream like `write(stream,
TOKEN_END)`, which will terminate the current transcoding block.

!!! note

    Call `flush(stream)` after `write(stream, TOKEN_END)` to make sure that all
    data are written to the underlying stream.
"""
const TOKEN_END = EndToken()

function Base.write(stream::TranscodingStream, ::EndToken)
    changemode!(stream, :write)
    flush_buffer1(stream)
    flushuntilend(stream)
    return 0
end

function Base.flush(stream::TranscodingStream)
    checkmode(stream)
    if stream.state.mode == :write
        flush_buffer1(stream)
        flush_buffer2(stream)
    end
    flush(stream.stream)
end


# Stats
# -----

"""
I/O statistics.

Its object has four fields:
- `in`: the number of bytes supplied into the stream
- `out`: the number of bytes consumed out of the stream
- `transcoded_in`: the number of bytes transcoded from the input buffer
- `transcoded_out`: the number of bytes transcoded to the output buffer

Note that, since the transcoding stream does buffering, `in` is `transcoded_in +
{size of buffered data}` and `out` is `transcoded_out - {size of buffered
data}`.
"""
struct Stats
    in::Int64
    out::Int64
    transcoded_in::Int64
    transcoded_out::Int64
end

function Base.show(io::IO, stats::Stats)
    println(io, summary(stats), ':')
    println(io, "  in: ", stats.in)
    println(io, "  out: ", stats.out)
    println(io, "  transcoded_in: ", stats.transcoded_in)
      print(io, "  transcoded_out: ", stats.transcoded_out)
end

"""
    stats(stream::TranscodingStream)

Create an I/O statistics object of `stream`.
"""
function stats(stream::TranscodingStream)
    state = stream.state
    mode = state.mode
    buffer1 = stream.buffer1
    buffer2 = stream.buffer2
    if mode === :idle
        transcoded_in = transcoded_out = in = out = 0
    elseif mode === :read || mode === :stop
        transcoded_out = buffer1.transcoded
        out = transcoded_out - buffersize(buffer1)
        if has_sharedbuf(stream)
            transcoded_in = stats(stream.stream).out
            in = transcoded_in
        else
            transcoded_in = buffer2.transcoded
            in = transcoded_in + buffersize(buffer2)
        end
    elseif mode === :write
        transcoded_in = buffer1.transcoded
        out = state.bytes_written_out
        transcoded_out = out
        if !has_sharedbuf(stream)
            transcoded_out += buffersize(buffer2)
        end
        in = transcoded_in + buffersize(buffer1)
    else
        throw_invalid_mode(mode)
    end
    return Stats(in, out, transcoded_in, transcoded_out)
end


# Buffering
# ---------

function fillbuffer(stream::TranscodingStream; eager::Bool = false)
    changemode!(stream, :read)
    buffer1 = stream.buffer1
    buffer2 = stream.buffer2
    nfilled::Int = 0
    while ((!eager && buffersize(buffer1) == 0) || (eager && makemargin!(buffer1, 0, eager = true) > 0)) && stream.state.mode != :stop
        if stream.state.code == :end
            if buffersize(buffer2) == 0 && eof(stream.stream)
                break
            end
            callstartproc(stream, :read)
        end
        makemargin!(buffer2, 1)
        readdata!(stream.stream, buffer2)
        _, Δout = callprocess(stream, buffer2, buffer1)
        nfilled += Δout
    end
    return nfilled
end

# Empty buffer1 by writing out data.
# `stream` must be in :write mode.
# Ensure there is margin available in buffer1 for at least one byte.
function flush_buffer1(stream::TranscodingStream)::Nothing
    state = stream.state
    buffer1 = stream.buffer1
    buffer2 = stream.buffer2
    while buffersize(buffer1) > 0
        if state.code == :end
            callstartproc(stream, :write)
        end
        flush_buffer2(stream)
        callprocess(stream, buffer1, buffer2)
    end
    # move positions to the start of the buffer
    @assert !iszero(makemargin!(buffer1, 0))
    return
end

# This is always called after `flush_buffer1(stream)`
function flushuntilend(stream::TranscodingStream)
    state = stream.state
    buffer1 = stream.buffer1
    buffer2 = stream.buffer2
    @assert buffersize(buffer1) == 0
    @assert stream.state.mode === :write
    while state.code != :end
        flush_buffer2(stream)
        callprocess(stream, buffer1, buffer2)
    end
    flush_buffer2(stream)
    return
end


# Interface to codec
# ------------------

# Call `startproc` with epilogne.
function callstartproc(stream::TranscodingStream, mode::Symbol)
    state = stream.state
    state.code = startproc(stream.codec, mode, state.error)
    if state.code == :error
        changemode!(stream, :panic)
    end
    return
end

# Call `process` with prologue and epilogue.
function callprocess(stream::TranscodingStream, inbuf::Buffer, outbuf::Buffer)
    state = stream.state
    makemargin!(
        outbuf,
        GC.@preserve(inbuf, minoutsize(stream.codec, buffermem(inbuf))),
    )
    Δin::Int, Δout::Int, state.code = GC.@preserve inbuf outbuf process(stream.codec, buffermem(inbuf), marginmem(outbuf), state.error)
    @debug(
        "called process()",
        code = state.code,
        input_size = buffersize(inbuf),
        output_size = marginsize(outbuf),
        input_delta = Δin,
        output_delta = Δout,
    )
    consumed!(inbuf, Δin;
        transcode = !has_sharedbuf(stream) || stream.state.mode === :write,
    ) # inbuf is buffer1 if mode is :write
    supplied!(outbuf, Δout;
        transcode = !has_sharedbuf(stream) || stream.state.mode !== :write,
    ) # outbuf is buffer1 if mode is not :write
    if has_sharedbuf(stream)
        if stream.state.mode === :write
            # this must be updated before throwing any error if outbuf is shared.
            stream.state.bytes_written_out += Δout
        end
    end
    if state.code == :error
        changemode!(stream, :panic)
    elseif state.code == :ok && Δin == Δout == 0
        # When no progress, expand the output buffer.
        makemargin!(outbuf, max(16, marginsize(outbuf) * 2))
    elseif state.code == :end && state.stop_on_end
        if stream.state.mode == :read
            if stream.stream isa TranscodingStream && !has_sharedbuf(stream) && !iszero(buffersize(inbuf))
                # unread data to match behavior if inbuf was shared.
                unread(stream.stream, view(inbuf.data, inbuf.bufferpos:inbuf.marginpos-1))
            end
            changemode!(stream, :stop)
        end
    end
    return Δin, Δout
end


# I/O operations
# --------------

# Read as much data as possbile from `input` to the margin of `output`.
# This function will not block if `input` has buffered data.
function readdata!(input::IO, output::Buffer)::Int
    if input isa TranscodingStream && input.buffer1 === output
        # Delegate the operation to the underlying stream for shared buffers.
        mode::Symbol = input.state.mode
        if mode === :idle || mode === :read
            return fillbuffer(input)
        else
            return 0
        end
    end
    nread::Int = 0
    navail = bytesavailable(input)
    if navail == 0 && marginsize(output) > 0 && !eof(input)
        nread += writebyte!(output, read(input, UInt8))
        navail = bytesavailable(input)
    end
    n = min(navail, marginsize(output))
    GC.@preserve output Base.unsafe_read(input, marginptr(output), n)
    supplied!(output, n)
    nread += n
    return nread
end

# Write all data to `output` from the buffer of `input`.
function flush_buffer2(stream::TranscodingStream)::Nothing
    output = stream.stream
    buffer2 = stream.buffer2
    state = stream.state
    @assert state.mode === :write
    if has_sharedbuf(stream)
        # Delegate the operation to the underlying stream for shared buffers.
        changemode!(output, :write)
        flush_buffer1(output)
    else
        while buffersize(buffer2) > 0
            n::Int = GC.@preserve buffer2 Base.unsafe_write(output, bufferptr(buffer2), buffersize(buffer2))
            n ≤ 0 && error("short write")
            consumed!(buffer2, n)
            state.bytes_written_out += n
            GC.safepoint()
        end
        # move positions to the start of the buffer
        @assert !iszero(makemargin!(buffer2, 0))
        GC.safepoint()
    end
    nothing
end


# Mode Transition
# ---------------

# Change the current mode.
function changemode!(stream::TranscodingStream, newmode::Symbol)
    state = stream.state
    mode = state.mode
    if mode == newmode
        # mode does not change
        return
    elseif newmode == :panic
        if !haserror(state.error)
            set_default_error!(state.error)
        end
        state.mode = newmode
        finalize_codec(stream.codec, state.error)
        throw(state.error[])
    elseif mode == :idle
        if newmode == :read || newmode == :write
            state.code = startproc(stream.codec, newmode, state.error)
            if state.code == :error
                changemode!(stream, :panic)
            end
            state.mode = newmode
            return
        elseif newmode == :close
            state.mode = newmode
            finalize_codec(stream.codec, state.error)
            return
        end
    elseif mode == :read
        if newmode == :close || newmode == :stop
            state.mode = newmode
            finalize_codec(stream.codec, state.error)
            return
        end
    elseif mode == :write
        if newmode == :close
            flush_buffer1(stream)
            flushuntilend(stream)
            state.mode = newmode
            finalize_codec(stream.codec, state.error)
            return
        end
    elseif mode == :stop
        if newmode == :close
            state.mode = newmode
            return
        end
    elseif mode == :panic
        throw_panic_error()
    end
    throw(ArgumentError("cannot change the mode from $(mode) to $(newmode)"))
end

# Check the current mode and throw an exception if needed.
function checkmode(stream::TranscodingStream)
    if stream.state.mode == :panic
        throw_panic_error()
    end
end

# Throw an argument error (must be called only when the mode is panic).
function throw_panic_error()
    throw(ArgumentError("stream is in unrecoverable error; only isopen and close are callable"))
end

# Set a defualt error.
function set_default_error!(error::Error)
    error[] = ErrorException("unknown error happened while processing data")
end

# Call the finalize method of the codec.
function finalize_codec(codec::Codec, error::Error)
    try
        finalize(codec)
    catch
        if haserror(error)
            throw(error[])
        else
            rethrow()
        end
    end
end

# IO Functions
# ------------

"""
    unsafe_read(input::IO, output::Ptr{UInt8}, nbytes::Int)::Int

Copy at most `nbytes` from `input` into `output`.

This function is similar to `Base.unsafe_read` but is different in some points:
- It does not throw `EOFError` when it fails to read `nbytes` from `input`.
- It returns the number of bytes written to `output`.
- It does not block if there are buffered data in `input`.
"""
function unsafe_read(input::IO, output::Ptr{UInt8}, nbytes::Integer)
    nbytes = convert(UInt, nbytes)
    p = output
    navail = bytesavailable(input)
    if navail == 0 && nbytes > 0 && !eof(input)
        b = read(input, UInt8)
        unsafe_store!(p, b)
        p += 1
        nbytes -= 1
        navail = bytesavailable(input)
    end
    n = min(navail, nbytes)
    Base.unsafe_read(input, p, n)
    p += n
    return Int(p - output)
end

# Transcoding Error
# =================

"""
Container of transcoding error.

An object of this type is used to notify the caller of an exception that
happened inside a transcoding method.  The `error` field is undefined at first
but will be filled when data processing failed. The error should be set by
calling the `setindex!` method (e.g. `error[] = ErrorException("error!")`).
"""
mutable struct Error
    error::Exception

    function Error()
        return new()
    end
end

# Test if an exception is set.
function haserror(error::Error)
    return isdefined(error, :error)
end

function Base.setindex!(error::Error, ex::Exception)
    @assert !haserror(error) "an error is already set"
    error.error = ex
    return error
end

function Base.getindex(error::Error)
    @assert haserror(error) "no error is set"
    return error.error
end

# This does not implement necessary interface methods.
struct InvalidCodec <: TranscodingStreams.Codec end

@testset "Invalid Codec" begin
    @test_throws MethodError read(TranscodingStream(InvalidCodec(), IOBuffer()))
end

using TranscodingStreams
using Random
using Test
using TranscodingStreams:
    TranscodingStreams,
    TranscodingStream,
    Error
using TestsForCodecPackages:
    test_roundtrip_read,
    test_roundtrip_write,
    test_roundtrip_transcode,
    test_roundtrip_lines,
    test_roundtrip_seekstart,
    test_roundtrip_fileio,
    test_chunked_read,
    test_chunked_write

# An insane codec for testing the codec APIs.
struct DoubleFrameEncoder <: TranscodingStreams.Codec 
    opened::Base.RefValue{Bool}
    stopped::Base.RefValue{Bool}
    got_stop_msg::Base.RefValue{Bool}
    pledged_in_size::Base.RefValue{Int64}
    in_size_count::Base.RefValue{Int64}
end

DoubleFrameEncoder() = DoubleFrameEncoder(Ref(false), Ref(false), Ref(false), Ref(Int64(-1)), Ref(Int64(0)))

function TranscodingStreams.process(
        codec     :: DoubleFrameEncoder,
        input     :: TranscodingStreams.Memory,
        output    :: TranscodingStreams.Memory,
        error_ref :: TranscodingStreams.Error,
    )
    pledged = codec.pledged_in_size[]
    if input.size == 0
        codec.got_stop_msg[] = true
    end

    if output.size < 2
        error_ref[] = ErrorException("requires a minimum of 2 bytes of output space")
        return 0, 0, :error
    elseif codec.stopped[]
        error_ref[] = ErrorException("cannot process after stopped")
        return 0, 0, :error
    elseif codec.got_stop_msg[] && input.size != 0
        error_ref[] = ErrorException("cannot accept more input after getting stop message")
        return 0, 0, :error
    elseif !codec.opened[]
        output[1] = UInt8('[')
        if pledged ∈ (0:9)
            output[2] = UInt8('0'+pledged)
        else
            output[2] = UInt8(' ')
        end
        codec.opened[] = true
        return 0, 2, :ok
    elseif codec.got_stop_msg[]
        # check in_size_count against pledged
        if pledged ∈ (0:9)
            if pledged > codec.in_size_count[]
                error_ref[] = ErrorException("pledged in size was too big")
                return 0, 0, :error
            end
        end
        output[1] = UInt8(' ')
        output[2] = UInt8(']')
        codec.stopped[] = true
        return 0, 2, :end
    else
        i = j = 0
        # check input.size against pledged
        if pledged ∈ (0:9)
            if input.size > pledged || pledged - input.size < codec.in_size_count[]
                error_ref[] = ErrorException("pledged in size was too small")
                return 0, 0, :error
            end
        end
        while i + 1 ≤ lastindex(input) && j + 2 ≤ lastindex(output)
            b = input[i+1]
            i += 1
            output[j+1] = output[j+2] = b
            j += 2
        end
        codec.in_size_count[] += i
        return i, j, :ok
    end
end

function TranscodingStreams.pledgeinsize(
        codec::DoubleFrameEncoder,
        insize::Int64,
        error::Error,
    )::Symbol
    if codec.opened[]
        error[] = ErrorException("pledgeinsize called after opening")
        return :error
    else
        codec.pledged_in_size[] = insize
        return :ok
    end
end

function TranscodingStreams.expectedsize(
              :: DoubleFrameEncoder,
        input :: TranscodingStreams.Memory)
    return input.size * 2 + 2 + 2
end

function TranscodingStreams.minoutsize(
        :: DoubleFrameEncoder,
        :: TranscodingStreams.Memory)
    return 2
end

function TranscodingStreams.startproc(codec::DoubleFrameEncoder, ::Symbol, error::Error)
    codec.opened[] = false
    codec.got_stop_msg[] = false
    codec.stopped[] = false
    codec.pledged_in_size[] = -1
    codec.in_size_count[] = 0
    return :ok
end

# An insane codec for testing the codec APIs.
struct DoubleFrameDecoder <: TranscodingStreams.Codec 
    state::Base.RefValue{Int}
    a::Base.RefValue{UInt8}
    b::Base.RefValue{UInt8}
end

DoubleFrameDecoder() = DoubleFrameDecoder(Ref(1), Ref(0x00), Ref(0x00))

function TranscodingStreams.process(
        codec     :: DoubleFrameDecoder,
        input     :: TranscodingStreams.Memory,
        output    :: TranscodingStreams.Memory,
        error_ref :: TranscodingStreams.Error,
    )
    Δin::Int = 0
    Δout::Int = 0

    function do_read(ref)
        iszero(input.size) && error("expected byte")
        if Δin + 1 ≤ lastindex(input)
            Δin += 1
            ref[] = input[Δin]
            true
        else
            false
        end
    end

    function do_write(x::UInt8)
        if Δout + 1 ≤ lastindex(output)
            Δout += 1
            output[Δout] = x
            true
        else
            false
        end
    end

    try
        # hacky resumable function using goto, just for fun.
        oldstate = codec.state[]
        if oldstate == 1
            @goto state1
        elseif oldstate == 2
            @goto state2
        elseif oldstate == 3
            @goto state3
        elseif oldstate == 4
            @goto state4
        elseif oldstate == 5
            @goto state5
        elseif oldstate == 6
            error("cannot process after ending")
        elseif oldstate == 7
            error("cannot process after erroring")
        else
            error("unexpected state $(oldstate)")
        end

        @label state1
        do_read(codec.a) || return (codec.state[]=1; (Δin, Δout, :ok))
        codec.a[] != UInt8('[') && error("expected [")
        @label state2
        do_read(codec.a) || return (codec.state[]=2; (Δin, Δout, :ok))
        codec.a[] ∉ (UInt8(' '), UInt8('0'):UInt8('9')...) && error("expected space or size")
        while true
            @label state3
            do_read(codec.a) || return (codec.state[]=3; (Δin, Δout, :ok))
            @label state4
            do_read(codec.b) || return (codec.state[]=4; (Δin, Δout, :ok))
            if codec.a[] == codec.b[]
                @label state5
                do_write(codec.a[]) || return (codec.state[]=5; (Δin, Δout, :ok))
            elseif codec.a[] == UInt8(' ') && codec.b[] == UInt8(']')
                break
            else
                error("expected matching bytes or space and ]")
            end
        end
        codec.state[]=6
        return Δin, Δout, :end
    catch e
        codec.state[]=7
        e isa ErrorException || rethrow()
        error_ref[] = e
        return Δin, Δout, :error
    end
end

function TranscodingStreams.startproc(codec::DoubleFrameDecoder, ::Symbol, error::Error)
    codec.state[] = 1
    codec.a[] = 0x00
    codec.b[] = 0x00
    return :ok
end

const DoubleFrameEncoderStream{S} = TranscodingStream{DoubleFrameEncoder,S} where S<:IO
DoubleFrameEncoderStream(stream::IO; kwargs...) = TranscodingStream(DoubleFrameEncoder(), stream; kwargs...)

const DoubleFrameDecoderStream{S} = TranscodingStream{DoubleFrameDecoder,S} where S<:IO
DoubleFrameDecoderStream(stream::IO; kwargs...) = TranscodingStream(DoubleFrameDecoder(), stream; kwargs...)


@testset "DoubleFrame Codecs" begin
    @test transcode(DoubleFrameEncoder, b"") == b"[0 ]"
    @test transcode(DoubleFrameEncoder, b"a") == b"[1aa ]"
    @test transcode(DoubleFrameEncoder, b"ab") == b"[2aabb ]"
    @test transcode(DoubleFrameEncoder(), b"") == b"[0 ]"
    @test transcode(DoubleFrameEncoder(), b"a") == b"[1aa ]"
    @test transcode(DoubleFrameEncoder(), b"ab") == b"[2aabb ]"
    @test transcode(DoubleFrameEncoder(), ones(UInt8,9)) == [b"[9"; ones(UInt8,18); b" ]";]
    @test transcode(DoubleFrameEncoder(), ones(UInt8,10)) == [b"[ "; ones(UInt8,20); b" ]";]

    @test_throws Exception transcode(DoubleFrameDecoder, b"")
    @test_throws Exception transcode(DoubleFrameDecoder, b" [")
    @test_throws Exception transcode(DoubleFrameDecoder, b" ]")
    @test_throws Exception transcode(DoubleFrameDecoder, b"[]")
    @test_throws Exception transcode(DoubleFrameDecoder, b" ")
    @test_throws Exception transcode(DoubleFrameDecoder, b"  ")
    @test_throws Exception transcode(DoubleFrameDecoder, b"aabb")
    @test_throws Exception transcode(DoubleFrameDecoder, b"[ ab ]")
    @test transcode(DoubleFrameDecoder, b"[  ]") == b""
    @test transcode(DoubleFrameDecoder, b"[ aa ]") == b"a"
    @test transcode(DoubleFrameDecoder, b"[ aabb ]") == b"ab"
    @test transcode(DoubleFrameDecoder, b"[ aaaa ]") == b"aa"
    @test transcode(DoubleFrameDecoder, b"[    ]") == b" "
    @test transcode(DoubleFrameDecoder, b"[   ]] ]") == b" ]"
    @test transcode(DoubleFrameDecoder, b"[ aa ][ bb ]") == b"ab"

    @testset "stop_on_end=true prevents underlying stream closing" begin
        sink = IOBuffer()
        stream = TranscodingStream(DoubleFrameDecoder(), sink, stop_on_end=true)
        write(stream, "[ yy ]")
        write(stream, "[ xx ]")
        close(stream)
        @test isopen(sink)
        @test take!(sink) == b"yx"
    end

    @testset "Issue #95" begin
        @test sprint() do outer
            inner = TranscodingStream(DoubleFrameEncoder(), outer, stop_on_end = true)
            println(inner, "Hello, world.")
            close(inner)
        end == "[ HHeelllloo,,  wwoorrlldd..\n\n ]"
    end

    @testset "TOKEN_END repeated doesn't create more empty frames" begin
        sink = IOBuffer()
        stream = TranscodingStream(DoubleFrameEncoder(), sink, stop_on_end=true)
        write(stream, TranscodingStreams.TOKEN_END)
        write(stream, TranscodingStreams.TOKEN_END)
        write(stream, "abc")
        write(stream, TranscodingStreams.TOKEN_END)
        write(stream, "de")
        write(stream, TranscodingStreams.TOKEN_END)
        write(stream, "") # This doesn't create an empty frame
        write(stream, TranscodingStreams.TOKEN_END)
        close(stream)
        @test String(take!(sink)) == "[  ][ aabbcc ][ ddee ]"
    end

    @testset "Issue #160 Safely close stream after failure" begin
        sink = IOBuffer()
        stream = TranscodingStream(DoubleFrameDecoder(), sink)
        write(stream, "abc")
        @test_throws ErrorException("expected [") close(stream)
        @test !isopen(stream)
        @test !isopen(sink)

        @testset "nested decoders" begin
            sink = IOBuffer()
            stream = TranscodingStream(DoubleFrameDecoder(), sink)
            stream2 = TranscodingStream(DoubleFrameDecoder(), stream)
            write(stream2, "abc")
            # "expected byte" error with caused by "expected ["
            @test_throws ErrorException("expected byte") close(stream2)
            @test !isopen(stream2)
            @test !isopen(stream)
            @test !isopen(sink)
        end
    end

    @testset "stop_on_end=true in nested streams" begin
        s1 = DoubleFrameDecoderStream(DoubleFrameEncoderStream(
            DoubleFrameDecoderStream(
                DoubleFrameEncoderStream(IOBuffer(b"")); 
                stop_on_end=true,
            )
        ))
        @test read(s1) == b""
        @test position(s1) == 0
        @test eof(s1)

        s2 = NoopStream(
            DoubleFrameDecoderStream(
                DoubleFrameEncoderStream(IOBuffer(b"")); 
                stop_on_end=true,
            )
        )
        @test read(s2) == b""
        @test position(s1) == 0
        @test eof(s2)
    end

    @testset "reading zero bytes from invalid stream" begin
        # This behavior is required to avoid breaking JLD2.jl
        # `s` must go into read mode, but not actually call `eof`
        for readnone in (io -> read!(io, UInt8[]), io -> read(io, 0), io -> skip(io, 0))
            for invalid_data in (b"", b"asdf")
                s = DoubleFrameDecoderStream(IOBuffer(invalid_data;read=true,write=true))
                @test iswritable(s)
                @test isreadable(s)
                readnone(s)
                @test !iswritable(s)
                @test isreadable(s)
                @test_throws ErrorException eof(s)
            end
        end
    end

    @testset "stats" begin
        @testset "read" begin
            stream = DoubleFrameEncoderStream(IOBuffer(b"foobar"))
            stat = TranscodingStreams.stats(stream)
            @test stat.in == 0
            @test stat.out == 0
            read(stream)
            stat = TranscodingStreams.stats(stream)
            @test stat.in == 6
            @test stat.transcoded_in == 6
            @test stat.transcoded_out == 16
            @test stat.out == 16
            close(stream)

            #nested Streams
            stream = DoubleFrameDecoderStream(DoubleFrameEncoderStream(IOBuffer(b"foobar")))
            stat = TranscodingStreams.stats(stream)
            @test stat.in == 0
            @test stat.out == 0
            read(stream)
            stat = TranscodingStreams.stats(stream)
            @test stat.in == 16
            @test stat.transcoded_in == 16
            @test stat.transcoded_out == 6
            @test stat.out == 6
            close(stream)
        end

        @testset "write" begin
            stream = DoubleFrameEncoderStream(IOBuffer())
            stat = TranscodingStreams.stats(stream)
            @test stat.in == 0
            @test stat.out == 0
            write(stream, b"foobar")
            stat = TranscodingStreams.stats(stream)
            @test stat.in == 6
            @test stat.transcoded_in == 0
            @test stat.transcoded_out == 0
            @test stat.out == 0
            flush(stream)
            stat = TranscodingStreams.stats(stream)
            @test stat.in == 6
            @test stat.transcoded_in == 6
            @test stat.transcoded_out == 14
            @test stat.out == 14
            write(stream, TranscodingStreams.TOKEN_END)
            stat = TranscodingStreams.stats(stream)
            @test stat.in == 6
            @test stat.transcoded_in == 6
            @test stat.transcoded_out == 16
            @test stat.out == 16
            close(stream)

            #nested Streams
            stream = DoubleFrameDecoderStream(DoubleFrameEncoderStream(IOBuffer()))
            stat = TranscodingStreams.stats(stream)
            @test stat.in == 0
            @test stat.out == 0
            write(stream, b"[ ffoooobbaarr ]")
            stat = TranscodingStreams.stats(stream)
            @test stat.in == 16
            @test stat.transcoded_in == 0
            @test stat.transcoded_out == 0
            @test stat.out == 0
            flush(stream)
            stat = TranscodingStreams.stats(stream)
            @test stat.in == 16
            @test stat.transcoded_in == 16
            @test stat.transcoded_out == 6
            @test stat.out == 6
            @test position(stream.stream) == 6
            close(stream)
        end
    end

    @testset "underlying stream fails" begin
        sink = IOBuffer(;maxsize=4)
        stream = DoubleFrameEncoderStream(sink)
        @test write(stream, "abcd") == 4
        # make sure flush doesn't go into an infinite loop
        @test_throws ErrorException("short write") flush(stream)
    end

    @testset "peek" begin
        stream = DoubleFrameDecoderStream(DoubleFrameEncoderStream(IOBuffer(
            codeunits("こんにちは")
        )))
        @test peek(stream) == 0xe3
        @test peek(stream, Char) == 'こ'
        @test peek(stream, Int32) == -476872221
        close(stream)
    end

    @testset "unread" begin
        stream = DoubleFrameDecoderStream(IOBuffer("[ ffoooobbaarr ]"))
        @test position(stream) == 0
        @test read(stream, 3) == b"foo"
        @test position(stream) == 3
        @test read(stream, 3) == b"bar"
        @test position(stream) == 6
        @test TranscodingStreams.unread(stream, b"baz") === nothing
        @test position(stream) == 3
        @test read(stream, 3) == b"baz"
        @test position(stream) == 6
        @test eof(stream)
        @test position(stream) == 6
        close(stream)
    end

    test_roundtrip_read(DoubleFrameEncoderStream, DoubleFrameDecoderStream)
    test_roundtrip_write(DoubleFrameEncoderStream, DoubleFrameDecoderStream)
    test_roundtrip_lines(DoubleFrameEncoderStream, DoubleFrameDecoderStream)
    test_roundtrip_seekstart(DoubleFrameEncoderStream, DoubleFrameDecoderStream)
    test_roundtrip_transcode(DoubleFrameEncoder, DoubleFrameDecoder)
    test_roundtrip_fileio(DoubleFrameEncoder, DoubleFrameDecoder)
    test_chunked_read(DoubleFrameEncoder, DoubleFrameDecoder)
    test_chunked_write(DoubleFrameEncoder, DoubleFrameDecoder)
end

# Buffer
# ======

# Data Layout
# -----------
#
# Buffered data are stored in `data` and three position fields are used to keep
# track of marked data, buffered data and margin.
#
#                     marked      buffer      margin
#                  |<-------->||<-------->||<-------->|
#       data   ....xxxxxxxxxxxxXXXXXXXXXXXX............
#              ^   ^           ^           ^          ^
#   position   1   markpos     bufferpos   marginpos  lastindex(data)
#
# `markpos` is positive iff there are marked data; otherwise it is set to zero.
# `markpos` ≤ `marginpos` and `bufferpos` ≤ `marginpos` must hold.

mutable struct Buffer
    # data and positions (see above)
    data::Vector{UInt8}
    markpos::Int
    bufferpos::Int
    marginpos::Int

    # the total number of transcoded bytes
    transcoded::Int64

    function Buffer(data::Vector{UInt8}, marginpos::Integer=length(data)+1)
        @assert 1 <= marginpos <= length(data)+1
        return new(data, 0, 1, marginpos, 0)
    end
end

function Buffer(size::Integer = 0)
    return Buffer(Vector{UInt8}(undef, size), 1)
end

function Buffer(data::Base.CodeUnits{UInt8}, args...)
    return Buffer(Vector{UInt8}(data), args...)
end

function Base.length(buf::Buffer)
    return length(buf.data)
end

function bufferptr(buf::Buffer)
    return pointer(buf.data, buf.bufferpos)
end

function buffersize(buf::Buffer)
    return buf.marginpos - buf.bufferpos
end

function buffermem(buf::Buffer)
    return Memory(bufferptr(buf), buffersize(buf))
end

function marginptr(buf::Buffer)
    return pointer(buf.data, buf.marginpos)
end

function marginsize(buf::Buffer)
    return lastindex(buf.data) - buf.marginpos + 1
end

function marginmem(buf::Buffer)
    return Memory(marginptr(buf), marginsize(buf))
end

function ismarked(buf::Buffer)
    return buf.markpos != 0
end

function mark!(buf::Buffer)
    return buf.markpos = buf.bufferpos
end

function unmark!(buf::Buffer)
    if buf.markpos == 0
        return false
    else
        buf.markpos = 0
        return true
    end
end

function reset!(buf::Buffer)
    @assert buf.markpos > 0
    @assert buf.markpos ≤ buf.marginpos
    buf.bufferpos = buf.markpos
    buf.markpos = 0
    return buf.bufferpos
end

# Notify that `n` bytes are consumed from `buf`.
function consumed!(buf::Buffer, n::Integer; transcode::Bool = false)
    buf.bufferpos += n
    if transcode
        buf.transcoded += n
    end
    return buf
end

# Notify that `n` bytes are supplied to `buf`.
function supplied!(buf::Buffer, n::Integer; transcode::Bool = false)
    buf.marginpos += n
    if transcode
        buf.transcoded += n
    end
    return buf
end

# Discard buffered data and initialize positions.
function initbuffer!(buf::Buffer)
    buf.markpos = buf.transcoded = 0
    buf.bufferpos = buf.marginpos = 1
    return buf
end

# Make margin with ≥`minsize` and return the size of it.
# If eager is true, it tries to move data even when the buffer has enough margin.
function makemargin!(buf::Buffer, minsize::Int; eager::Bool = false)
    @assert minsize ≥ 0
    if buffersize(buf) == 0 && buf.markpos == 0
        buf.bufferpos = buf.marginpos = 1
    end
    if marginsize(buf) < minsize || eager
        # datapos refer to the leftmost position of data that must not be
        # discarded. We can left-shift to discard all data before this
        datapos = if iszero(buf.markpos)
            # If data is not marked we must not discard buffered (nonconsumed) data
            buf.bufferpos
        else
            # Else, we must not consume marked or buffered data
            min(buf.markpos, buf.bufferpos)
        end
        datasize = buf.marginpos - datapos
        # Shift data left in buffer to make space for new data
        copyto!(buf.data, 1, buf.data, datapos, datasize)
        shift = datapos - 1
        if buf.markpos > 0
            buf.markpos -= shift
        end
        buf.bufferpos -= shift
        buf.marginpos -= shift
    end
    # If there is still not enough margin, we expand buffer.
    # At least enough for minsize, but otherwise 1.5 times
    if marginsize(buf) < minsize
        datasize = length(buf.data)
        resize!(buf.data, max(Base.checked_add(buf.marginpos, minsize) - 1, datasize + div(datasize, 2)))
    end
    @assert marginsize(buf) ≥ minsize
    return marginsize(buf)
end

# Read a byte.
function readbyte!(buf::Buffer)
    b = buf.data[buf.bufferpos]
    consumed!(buf, 1)
    return b
end

# Write a byte.
function writebyte!(buf::Buffer, b::UInt8)
    buf.data[buf.marginpos] = b
    supplied!(buf, 1)
    return 1
end

# Skip `n` bytes in the buffer.
function skipbuffer!(buf::Buffer, n::Integer)
    @assert n ≤ buffersize(buf)
    consumed!(buf, n)
    return buf
end

# Copy data from `data` to `buf`.
function copydata!(buf::Buffer, data::Ptr{UInt8}, nbytes::Integer)
    makemargin!(buf, Int(nbytes))
    GC.@preserve buf unsafe_copyto!(marginptr(buf), data, nbytes)
    supplied!(buf, nbytes)
    return buf
end

# Copy data from `buf` to `data`.
function copydata!(data::Ptr{UInt8}, buf::Buffer, nbytes::Integer)
    # NOTE: It's caller's responsibility to ensure that the buffer has at least
    # nbytes.
    @assert buffersize(buf) ≥ nbytes
    GC.@preserve buf unsafe_copyto!(data, bufferptr(buf), nbytes)
    consumed!(buf, nbytes)
    return data
end

# Insert data to the current buffer.
# `data` must not alias `buf`
function insertdata!(buf::Buffer, data::Union{AbstractVector{UInt8}, Memory})
    nbytes = Int(length(data))
    makemargin!(buf, nbytes)
    datapos = if iszero(buf.markpos)
        # If data is not marked we must not discard buffered (nonconsumed) data
        buf.bufferpos
    else
        # Else, we must not consume marked or buffered data
        min(buf.markpos, buf.bufferpos)
    end
    datasize = buf.marginpos - datapos
    copyto!(buf.data, datapos + nbytes, buf.data, datapos, datasize)
    for i in 0:nbytes-1
        buf.data[buf.bufferpos + i] = data[firstindex(data) + i]
    end
    supplied!(buf, nbytes)
    if !iszero(buf.markpos)
        buf.markpos += nbytes
    end
    @assert buf.markpos ≤ buf.marginpos
    return buf
end

# Find the first occurrence of a specific byte.
function findbyte(buf::Buffer, byte::UInt8)
    p = GC.@preserve buf ccall(
        :memchr,
        Ptr{UInt8},
        (Ptr{UInt8}, Cint, Csize_t),
        pointer(buf.data, buf.bufferpos), byte, buffersize(buf))
    if p == C_NULL
        return marginptr(buf)
    else
        return p
    end
end

# Memory
# ======

"""
A contiguous memory.

This type works like a `Vector` method.
"""
struct Memory
    ptr::Ptr{UInt8}
    size::UInt
end

@inline function Base.length(mem::Memory)
    return mem.size
end

@inline function Base.firstindex(mem::Memory)
    return 1
end

@inline function Base.lastindex(mem::Memory)
    return Int(mem.size)
end

@inline function Base.checkbounds(mem::Memory, i::Integer)
    if !(1 ≤ i ≤ lastindex(mem))
        throw(BoundsError(mem, i))
    end
end

@inline function Base.getindex(mem::Memory, i::Integer)
    @boundscheck checkbounds(mem, i)
    return unsafe_load(mem.ptr, i)
end

@inline function Base.setindex!(mem::Memory, val::UInt8, i::Integer)
    @boundscheck checkbounds(mem, i)
    return unsafe_store!(mem.ptr, val, i)
end

# Codec Interfaces
# ================

"""
An abstract codec type.

Any codec supporting the transcoding protocol must be a subtype of this type.

Transcoding protocol
--------------------

Transcoding proceeds by calling some functions in a specific way. We call this
"transcoding protocol" and any codec must implement it as described below.

There are six functions for a codec to implement:
- `expectedsize`: return the expected size of transcoded data
- `pledgeinsize`: tell the codec the total input size
- `minoutsize`: return the minimum output size of `process`
- `initialize`: initialize the codec
- `finalize`: finalize the codec
- `startproc`: start processing with the codec
- `process`: process data with the codec.

These are defined in the `TranscodingStreams` and a new codec type must extend
these methods if necessary.  Implementing a `process` method is mandatory but
others are optional.  `expectedsize`, `minoutsize`, `pledgeinsize`, `initialize`, `finalize`,
and `startproc` have a default implementation.

Your codec type is denoted by `C` and its object by `codec`.

Errors that occur in these methods are supposed to be unrecoverable and the
stream will go to the panic mode. Only `Base.isopen` and `Base.close` are
available in that mode.

### `expectedsize`

The `expectedsize(codec::C, input::Memory)::Int` method takes `codec` and
`input`, and returns the expected size of transcoded data. This method will be
used as a hint to determine the size of a data buffer when `transcode` is
called. A good hint will reduce the number of buffer resizing and hence result
in better performance.

### `pledgeinsize`

The `pledgeinsize(codec::C, insize::Int64, error::Error)::Symbol` method is used
when `transcode` is called to tell the `codec` the total input size.
This is called after `startproc` and before `process`. Some
compressors can add this total input size to a header, making `expectedsize`
accurate during later decompression. By default this just returns `:ok`.
If there is an error, the return code must be `:error` and the `error` argument
must be set to an exception object. Setting an inaccurate `insize` may cause the
codec to error later on while processing data. A negative `insize` means unknown
content size.

### `minoutsize`

The `minoutsize(codec::C, input::Memory)::Int` method takes `codec` and `input`,
and returns the minimum required size of the output memory when `process` is
called.  For example, an encoder of base64 will write at least four bytes to the
output and hence it is reasonable to return 4 with this method.

### `initialize`

The `initialize(codec::C)::Void` method takes `codec` and returns `nothing`.
This is called once and only once before starting any data processing.
Therefore, you may initialize `codec` (e.g. allocating memory needed to process
data) with this method. If initialization fails for some reason, it may throw an
exception and no other methods (including `finalize`) will be called. Therefore,
you need to release the memory before throwing an exception.

### `finalize`

The `finalize(codec::C)::Void` method takes `codec` and returns `nothing`.  This
is called once and only only once just before the transcoding stream goes to the
close mode (i.e. when `Base.close` is called) or just after `startproc` or
`process` throws an exception. Other errors that happen inside the stream (e.g.
`EOFError`) will not call this method. Therefore, you may finalize `codec` (e.g.
freeing memory) with this method. If finalization fails for some reason, it may
throw an exception. You should release the allocated memory in codec before
returning or throwing an exception in `finalize` because otherwise nobody cannot
release the memory. Even when an exception is thrown while finalizing a stream,
the stream will become the close mode for safety.

### `startproc`

The `startproc(codec::C, mode::Symbol, error::Error)::Symbol` method takes
`codec`, `mode`, and `error`, and returns a status code. This resets the state
of the codec and is called before the stream starts processing data.
After a call to `startproc`, `pledgeinsize` can be optionally called.
`mode` is either `:read` or `:write`. The
return code must be `:ok` if `codec` is ready to process data.  Otherwise,
it must be `:error` and the `error` argument must be set to an exception object.

### `process`

The `process(codec::C, input::Memory, output::Memory,
error::Error)::Tuple{Int,Int,Symbol}` method takes `codec`, `input`, `output`
and `error`, and returns a consumed data size, a produced data size and a status
code. This is called repeatedly while processing data. The input (`input`) and
output (`output`) data are a `Memory` object, which is a pointer to a contiguous
memory region with size. You must read input data from `input`, transcode the
bytes, and then write the output data to `output`.  Finally you need to return
the size of read data, the size of written data, and `:ok` status code so that
the caller can know how many bytes are consumed and produced in the method.
When transcoding reaches the end of a data stream, it is notified to this method
by empty input. In that case, the method need to write the buffered data (if
any) to `output`. If there is no data to write, the status code must be set to
`:end`. The `process` method will be called repeatedly until it returns `:end`
status code. If an error happens while processing data, the `error` argument
must be set to an exception object and the return code must be `:error`.
"""
abstract type Codec end


# Methods
# -------

"""
    expectedsize(codec::Codec, input::Memory)::Int

Return the expected size of the transcoded `input` with `codec`.

The default method returns `input.size`.
"""
function expectedsize(codec::Codec, input::Memory)::Int
    return input.size
end

"""
    pledgeinsize(codec::Codec, insize::Int64, error::Error)::Symbol

Tell the codec the total input size.

The default method does nothing and returns `:ok`.
"""
function pledgeinsize(codec::Codec, insize::Int64, error::Error)::Symbol
    return :ok
end

"""
    minoutsize(codec::Codec, input::Memory)::Int

Return the minimum output size to be ensured when calling `process`.

The default method returns `max(1, div(input.size, 4))`.
"""
function minoutsize(codec::Codec, input::Memory)::Int
    return max(1, div(input.size, 4))
end

"""
    initialize(codec::Codec)::Void

Initialize `codec`.

The default method does nothing.
"""
function initialize(codec::Codec)
    return nothing
end

"""
    finalize(codec::Codec)::Void

Finalize `codec`.

The default method does nothing.
"""
function finalize(codec::Codec)::Nothing
    return nothing
end

"""
    startproc(codec::Codec, mode::Symbol, error::Error)::Symbol

Start data processing with `codec` of `mode`.

The default method does nothing and returns `:ok`.
"""
function startproc(codec::Codec, mode::Symbol, error::Error)::Symbol
    return :ok
end

"""
    process(codec::Codec, input::Memory, output::Memory, error::Error)::Tuple{Int,Int,Symbol}

Do data processing with `codec`.

There is no default method.
"""
function process(codec::Codec, input::Memory, output::Memory, error::Error)::Tuple{Int,Int,Symbol}
    # no default method
    throw(MethodError(process, (codec, input, output, error)))
end

# Transcode
# =========

"""
    transcode(
        ::Type{C},
        data::Union{Vector{UInt8},Base.CodeUnits{UInt8}},
    )::Vector{UInt8} where {C<:Codec}

Transcode `data` by applying a codec `C()`.

Note that this method does allocation and deallocation of `C()` in every call,
which is handy but less efficient when transcoding a number of objects.
`transcode(codec, data)` is a recommended method in terms of performance.

Examples
--------

```julia
julia> using CodecZlib

julia> data = b"abracadabra";

julia> compressed = transcode(ZlibCompressor, data);

julia> decompressed = transcode(ZlibDecompressor, compressed);

julia> String(decompressed)
"abracadabra"
```
"""
function Base.transcode(::Type{C}, args...) where {C<:Codec}
    codec = C()
    initialize(codec)
    try
        return transcode(codec, args...)
    finally
        finalize(codec)
    end
end

# Disambiguate `Base.transcode(::Type{C}, args...)` above from
# `Base.transcode(T, ::String)` in Julia `Base`
function Base.transcode(codec::Type{C}, src::String) where {C<:Codec}
    return invoke(transcode, Tuple{Any, String}, codec, src)
end

_default_output_buffer(codec, input) = Buffer(
    GC.@preserve(input, initial_output_size(
        codec,
        buffermem(input)
    ))
)

"""
    transcode(
        codec::Codec,
        data::Union{Vector{UInt8},Base.CodeUnits{UInt8},Buffer},
        [output::Union{Vector{UInt8},Base.CodeUnits{UInt8},Buffer}],
    )::Vector{UInt8}

Transcode `data` by applying `codec`.

If `output` is unspecified, then this method will allocate it.

Note that this method does not initialize or finalize `codec`. This is
efficient when you transcode a number of pieces of data, but you need to call
[`TranscodingStreams.initialize`](@ref) and
[`TranscodingStreams.finalize`](@ref) explicitly.

Examples
--------

```julia
julia> using CodecZlib

julia> data = b"abracadabra";

julia> codec = ZlibCompressor();

julia> TranscodingStreams.initialize(codec)

julia> compressed = Vector{UInt8}()

julia> transcode(codec, data, compressed);

julia> TranscodingStreams.finalize(codec)

julia> codec = ZlibDecompressor();

julia> TranscodingStreams.initialize(codec)

julia> decompressed = transcode(codec, compressed);

julia> TranscodingStreams.finalize(codec)

julia> String(decompressed)
"abracadabra"

```
"""
function Base.transcode(
    codec::Codec,
    input::Buffer,
    output::Union{Buffer,Nothing} = nothing,
)
    output = (output === nothing ? _default_output_buffer(codec, input) : initbuffer!(output))
    transcode!(output, codec, input)
end

"""
    transcode!(output::Buffer, codec::Codec, input::Buffer)

Transcode `input` by applying `codec` and storing the results in `output`
with validation of input and output.  Note that this method does not initialize
or finalize `codec`. This is efficient when you transcode a number of
pieces of data, but you need to call [`TranscodingStreams.initialize`](@ref) and
[`TranscodingStreams.finalize`](@ref) explicitly.
"""
function transcode!(
    output::Buffer,
    codec::Codec,
    input::Buffer,
)
    Base.mightalias(input.data, output.data) && error(
        "input and outbut buffers must be independent"
    )
    unsafe_transcode!(output, codec, input)
end

"""
    unsafe_transcode!(output::Buffer, codec::Codec, input::Buffer)

Transcode `input` by applying `codec` and storing the results in `output`
without validation of input or output.  Note that this method does not initialize
or finalize `codec`. This is efficient when you transcode a number of
pieces of data, but you need to call [`TranscodingStreams.initialize`](@ref) and
[`TranscodingStreams.finalize`](@ref) explicitly.
"""
function unsafe_transcode!(
    output::Buffer,
    codec::Codec,
    input::Buffer,
)
    error = Error()
    code = startproc(codec, :write, error)
    if code === :error
        @goto error
    end
    if pledgeinsize(codec, Int64(buffersize(input)), error) === :error
        @goto error
    end
    n = GC.@preserve input minoutsize(codec, buffermem(input))
    @label process
    makemargin!(output, n)
    Δin, Δout, code = GC.@preserve input output process(codec, buffermem(input), marginmem(output), error)
    @debug(
        "called process()",
        code = code,
        input_size = buffersize(input),
        output_size = marginsize(output),
        input_delta = Δin,
        output_delta = Δout,
    )
    consumed!(input, Δin)
    supplied!(output, Δout)
    if code === :error
        @goto error
    elseif code === :end
        if buffersize(input) > 0
            if startproc(codec, :write, error) === :error
                @goto error
            end
            if pledgeinsize(codec, Int64(buffersize(input)), error) === :error
                @goto error
            end
            n = GC.@preserve input minoutsize(codec, buffermem(input))
            @goto process
        end
        resize!(output.data, output.marginpos - 1)
        return output.data
    else
        n = GC.@preserve input max(Δout, minoutsize(codec, buffermem(input)))
        @goto process
    end
    @label error
    if !haserror(error)
        set_default_error!(error)
    end
    throw(error[])
end

Base.transcode(codec::Codec, data::Buffer, output::ByteData) =
    transcode(codec, data, Buffer(output))

Base.transcode(codec::Codec, data::ByteData, args...) =
    transcode(codec, Buffer(data), args...)

unsafe_transcode!(codec::Codec, data::Buffer, output::ByteData) =
    unsafe_transcode!(Buffer(output), codec, data)

unsafe_transcode!(codec::Codec, data::ByteData, args...) =
    unsafe_transcode!(codec, Buffer(data), args...)

# Return the initial output buffer size.
function initial_output_size(codec::Codec, input::Memory)
    return max(
        minoutsize(codec, input),
        expectedsize(codec, input),
        8,  # just in case where both minoutsize and expectedsize are foolish
    )
end

module TranscodingStreams

export
    TranscodingStream,
    Noop,
    NoopStream

const ByteData = Union{Vector{UInt8},Base.CodeUnits{UInt8}}

include("memory.jl")
include("buffer.jl")
include("error.jl")
include("codec.jl")
include("state.jl")
include("stream.jl")
include("io.jl")
include("noop.jl")
include("transcode.jl")

end # module

# Noop Codec
# ==========

"""
    Noop()

Create a noop codec.

Noop (no operation) is a codec that does nothing. The data read from or written
to the stream are kept as-is without any modification. This is often useful as a
buffered stream or an identity element of a composition of streams.

The implementations are specialized for this codec. For example, a `Noop` stream
uses only one buffer rather than a pair of buffers, which avoids copying data
between two buffers and the throughput will be larger than a naive
implementation.
"""
struct Noop <: Codec end

const NoopStream{S} = TranscodingStream{Noop,S} where S<:IO

"""
    NoopStream(stream::IO)

Create a noop stream.
"""
function NoopStream(stream::IO; kwargs...)
    return TranscodingStream(Noop(), stream; kwargs...)
end

function TranscodingStream(codec::Noop, stream::IO;
                           bufsize::Integer=DEFAULT_BUFFER_SIZE,
                           stop_on_end::Bool=false,
                           sharedbuf::Bool=(stream isa TranscodingStream))
    checkbufsize(bufsize)
    checksharedbuf(sharedbuf, stream)
    if sharedbuf
        buffer = stream.buffer1
    else
        buffer = Buffer(bufsize)
    end
    state = State(buffer, buffer)
    state.stop_on_end = stop_on_end
    return TranscodingStream(codec, stream, state)
end

"""
    position(stream::NoopStream)

Get the current poition of `stream`.

Note that this method may return a wrong position when
- some data have been inserted by `TranscodingStreams.unread`, or
- the position of the wrapped stream has been changed outside of this package.
"""
function Base.position(stream::NoopStream)::Int64
    mode = stream.state.mode
    if !isopen(stream)
        throw_invalid_mode(mode)
    elseif mode === :idle
        return Int64(0)
    elseif has_sharedbuf(stream)
        return position(stream.stream)
    elseif mode === :write
        return position(stream.stream) + buffersize(stream.buffer1)
    else # read
        return position(stream.stream) - buffersize(stream.buffer1)
    end
    @assert false "unreachable"
end

function Base.seek(stream::NoopStream, pos::Integer)
    mode = stream.state.mode
    if mode === :write
        flush_buffer2(stream)
    end
    seek(stream.stream, pos)
    initbuffer!(stream.buffer1)
    return stream
end

function Base.seekstart(stream::NoopStream)
    mode = stream.state.mode
    if mode === :write
        flush_buffer2(stream)
    end
    seekstart(stream.stream)
    initbuffer!(stream.buffer1)
    return stream
end

function Base.seekend(stream::NoopStream)
    mode = stream.state.mode
    if mode === :write
        flush_buffer2(stream)
    end
    seekend(stream.stream)
    initbuffer!(stream.buffer1)
    return stream
end

function Base.write(stream::NoopStream, b::UInt8)::Int
    changemode!(stream, :write)
    if has_sharedbuf(stream)
        # directly write data to the underlying stream
        write(stream.stream, b)
        stream.state.bytes_written_out += 1
    else
        buffer1 = stream.buffer1
        marginsize(buffer1) > 0 || flush_buffer2(stream)
        writebyte!(buffer1, b)
    end
    return 1
end

function Base.unsafe_write(stream::NoopStream, input::Ptr{UInt8}, nbytes::UInt)::Int
    changemode!(stream, :write)
    Int(nbytes) # Error if nbytes > typemax Int
    if has_sharedbuf(stream)
        # directly write data to the underlying stream
        n = Int(unsafe_write(stream.stream, input, nbytes))
        stream.state.bytes_written_out += n
        return n
    end
    buffer = stream.buffer1
    if marginsize(buffer) ≥ nbytes
        copydata!(buffer, input, Int(nbytes))
        return Int(nbytes)
    else
        flush_buffer2(stream)
        # directly write data to the underlying stream
        n = Int(unsafe_write(stream.stream, input, nbytes))
        stream.state.bytes_written_out += n
        return n
    end
end

initial_output_size(codec::Noop, input::Memory) = length(input)

function process(codec::Noop, input::Memory, output::Memory, error::Error)
    iszero(length(input)) && return (0, 0, :end)
    n::Int = min(length(input), length(output))
    unsafe_copyto!(output.ptr, input.ptr, n)
    (n, n, :ok)
end

# Stats
# -----

function stats(stream::NoopStream)
    state = stream.state
    mode = state.mode
    buffer = stream.buffer1
    @assert buffer === stream.buffer2
    if mode === :idle
        in = out = 0
    elseif mode === :read
        out = buffer.transcoded - buffersize(buffer)
        if has_sharedbuf(stream)
            in = out
        else
            in = buffer.transcoded
        end
    elseif mode === :write
        out = stream.state.bytes_written_out
        in = out
        if !has_sharedbuf(stream)
            in += buffersize(buffer)
        end
    else
        throw_invalid_mode(mode)
    end
    return Stats(in, out, out, out)
end


# Buffering
# ---------
#
# These methods are overloaded for the `Noop` codec because it has only one
# buffer for efficiency.

function fillbuffer(stream::NoopStream; eager::Bool = false)::Int
    changemode!(stream, :read)
    buffer = stream.buffer1
    @assert buffer === stream.buffer2
    if has_sharedbuf(stream)
        # Delegate the operation when buffers are shared.
        underlying_mode::Symbol = stream.stream.state.mode
        if underlying_mode === :idle || underlying_mode === :read
            return fillbuffer(stream.stream, eager = eager)
        else
            return 0
        end
    end
    nfilled::Int = 0
    while ((!eager && buffersize(buffer) == 0) || (eager && makemargin!(buffer, 0, eager = true) > 0)) && !eof(stream.stream)
        makemargin!(buffer, 1)
        nfilled += readdata!(stream.stream, buffer)
    end
    buffer.transcoded += nfilled
    return nfilled
end

# Empty buffer1 by writing out data.
# `stream` must be in :write mode.
# Ensure there is margin available in buffer1 for at least one byte.
function flush_buffer1(stream::NoopStream)::Nothing
    flush_buffer2(stream)
end

# This is always called after `flush_buffer1(stream)`
function flushuntilend(stream::NoopStream)
    @assert iszero(buffersize(stream.buffer1))
    return
end

# Basic Supposition.jl tests to ensure nested streams can be read and written to.

using Supposition: Data, @composed, @check, event!, produce!

include("../test/codecdoubleframe.jl")

const TS_kwarg = @composed (
    bufsize=Data.Integers(1, 2^10),
    stop_on_end=Data.Booleans(),
    sharedbuf=Data.Booleans(),
) -> (
    if sharedbuf
        # default sharedbuf
        (;bufsize, stop_on_end)
    else
        # sharedbuf = false
        (;bufsize, stop_on_end, sharedbuf)
    end
)

const datas = Data.Vectors(Data.Integers{UInt8}())
const noopcodecs = Data.Vectors(Data.Just(Noop); max_size=3)

function codecwrap(child)
    map(child) do x
        DataType[
            DoubleFrameEncoder;
            x;
            DoubleFrameDecoder;
        ]
    end | map(Data.Vectors(child; min_size=2, max_size=2)) do x
        reduce(vcat, x)
    end
end

# possible vector of codec types that when read from
# should be equivalent to a Noop. 
# Every encoder is balanced with a decoder.
const codecs = Data.Recursive(noopcodecs, codecwrap; max_layers=4)

function prepare_kws(codecs)
    # res will be a nicely printed summary of the layers of the stream.
    res = []
    for codec in codecs
        kw = Data.produce!(TS_kwarg)
        push!(res, (codec, kw))
    end
    res
end

const read_codecs_kws = map(prepare_kws, codecs)

function wrap_stream(codecs_kws, io::IO)::IO
    event!("IOBuffer:", nothing)
    foldl(codecs_kws; init=io) do stream, (codec, kw)
        event!("codec:", (codec, kw))
        TranscodingStream(codec(), stream; kw...)
    end
end

# Read data using various means.
# These function read a vector of bytes from io,
# if io is eof they should return an empty vector.
read_methods = Data.SampledFrom([
    function read_byte(io)
        eof(io) && return UInt8[]
        [read(io, UInt8)]
    end,
    function read_by_readuntil_keep(io)
        delim = 0x01
        readuntil(io, delim; keep=true)
    end,
    function read_by_Base_unsafe_read(io)
        n = bytesavailable(io)
        ret = zeros(UInt8, n)
        GC.@preserve ret Base.unsafe_read(io, pointer(ret), n)
        ret
    end,
    function read_by_readavailable(io)
        readavailable(io)
    end,
    function read_by_readbytes1(io)
        ret = zeros(UInt8, 10000)
        n = readbytes!(io, ret)
        ret[1:n]
    end,
    function read_by_readbytes2(io)
        ret = zeros(UInt8, 0)
        n = readbytes!(io, ret, 10000)
        ret[1:n]
    end
])

# Return true if the stats of a stream are self consistent
# This function assumes stream was never seeked.
function is_stats_consistent(stream)
    if stream isa TranscodingStream
        s = TranscodingStreams.stats(stream)
        inner_pos = position(stream.stream)
        pos = position(stream)
        # event!("stats(stream)", s)
        # event!("position(stream.stream)", inner_pos)
        # event!("position(stream)", pos)
        if isreadable(stream)
            s.out == pos || return false
            s.in == inner_pos || return false
        else
            iswritable(stream) || return false
            s.in == pos || return false
            s.out == inner_pos || return false
        end
        s.transcoded_in ≤ s.in || return false
        s.transcoded_out ≥ s.out || return false
    end
    true
end

@testset "read" begin
    @check function read_byte_data(
            kws=read_codecs_kws,
            data=datas,
        )
        stream = wrap_stream(kws, IOBuffer(data))
        for i in 1:length(data)
            position(stream) == i-1 || return false
            is_stats_consistent(stream) || return false
            read(stream, UInt8) == data[i] || return false
        end
        is_stats_consistent(stream) || return false
        eof(stream)
    end
    @check function read_data(
            kws=read_codecs_kws,
            data=datas,
        )
        stream = wrap_stream(kws, IOBuffer(data))
        read(stream) == data || return false
        is_stats_consistent(stream) || return false
        eof(stream)
    end
    @check function read_data_methods(
            kws=read_codecs_kws,
            data=datas,
            rs=Data.Vectors(read_methods),
        )
        stream = wrap_stream(kws, IOBuffer(data))
        x = UInt8[]
        for r in rs
            d = r(stream)
            append!(x, d)
            length(x) == position(stream) || return false
        end
        is_stats_consistent(stream) || return false
        x == data[eachindex(x)]
    end
end

# flush all nested streams and return final data
function take_all(stream)
    if stream isa Base.GenericIOBuffer
        seekstart(stream)
        read(stream)
    else
        write(stream, TranscodingStreams.TOKEN_END)
        flush(stream)
        take_all(stream.stream)
    end
end

const write_codecs_kws = map(reverse, read_codecs_kws)

@testset "write" begin
    @check function write_data(
            kws=write_codecs_kws,
            data=datas,
        )
        stream = wrap_stream(kws, IOBuffer())
        write(stream, data) == length(data) || return false
        take_all(stream) == data || return false
        is_stats_consistent(stream) || return false
        true
    end
    @check function write_byte_data(
            kws=write_codecs_kws,
            data=datas,
        )
        stream = wrap_stream(kws, IOBuffer())
        for i in 1:length(data)
            position(stream) == i-1 || return false
            is_stats_consistent(stream) || return false
            write(stream, data[i]) == 1 || return false
        end
        take_all(stream) == data || return false
        is_stats_consistent(stream) || return false
        true
    end
end

using Documenter
using TranscodingStreams

makedocs(
    sitename="TranscodingStreams.jl",
    modules=[TranscodingStreams],
    pages=["index.md", "examples.md", "reference.md", "migrating.md", "devnotes.md"],
    format=Documenter.HTML(; assets=["assets/custom.css"]),
)

deploydocs(repo="github.com/JuliaIO/TranscodingStreams.jl.git", push_preview=true)

Reference
=========

```@meta
CurrentModule = TranscodingStreams
```

TranscodingStream
-----------------

```@docs
TranscodingStream(codec::Codec, stream::IO)
transcode
TranscodingStreams.unsafe_transcode!

TranscodingStreams.transcode!
TranscodingStreams.TOKEN_END
TranscodingStreams.unsafe_read
TranscodingStreams.unread
TranscodingStreams.unsafe_unread
Base.position(stream::TranscodingStream)
Base.skip
```

Statistics
----------

```@docs
TranscodingStreams.Stats
TranscodingStreams.stats
```

Codec
-----

```@docs
TranscodingStreams.Noop
TranscodingStreams.NoopStream
Base.position(::NoopStream)
```

```@docs
TranscodingStreams.Codec
TranscodingStreams.expectedsize
TranscodingStreams.pledgeinsize
TranscodingStreams.minoutsize
TranscodingStreams.initialize
TranscodingStreams.finalize
TranscodingStreams.startproc
TranscodingStreams.process
```

Internal types
--------------

```@docs
TranscodingStreams.Memory
TranscodingStreams.Error
TranscodingStreams.State
```

Examples
========

Read lines from a gzip-compressed file
--------------------------------------

The following snippet is an example of using CodecZlib.jl, which exports
`GzipDecompressorStream{S}` as an alias of
`TranscodingStream{GzipDecompressor,S}`, where `S` is a subtype of `IO`:
```julia
using CodecZlib
stream = GzipDecompressorStream(open("data.txt.gz"))
for line in eachline(stream)
    # do something...
end
close(stream)
```

Note that the last `close` call closes the wrapped file as well.
Alternatively, `open(<stream type>, <filepath>) do ... end` syntax closes the
file at the end:
```julia
using CodecZlib
open(GzipDecompressorStream, "data.txt.gz") do stream
    for line in eachline(stream)
        # do something...
    end
end
```

Read compressed data from a pipe
--------------------------------

The input is not limited to usual files. You can read data from a pipe
(actually, any `IO` object that implements standard I/O methods) as follows:
```julia
using CodecZlib
proc = open(`cat some.data.gz`)
stream = GzipDecompressorStream(proc)
for line in eachline(stream)
    # do something...
end
close(stream)  # This will finish the process as well.
```

Save a data matrix with Zstd compression
----------------------------------------

Writing compressed data is easy. One thing you need to keep in mind is to call
`close` after writing data; otherwise, the output file will be incomplete:
```julia
using CodecZstd
using DelimitedFiles
mat = randn(100, 100)
stream = ZstdCompressorStream(open("data.mat.zst", "w"))
writedlm(stream, mat)
close(stream)
```

Of course, `open(<stream type>, ...) do ... end` just works:
```julia
using CodecZstd
using DelimitedFiles
mat = randn(100, 100)
open(ZstdCompressorStream, "data.mat.zst", "w") do stream
    writedlm(stream, mat)
end
```

Explicitly finish transcoding by writing `TOKEN_END`
----------------------------------------------------

When writing data, the end of a data stream is indicated by calling `close`,
which writes an epilogue if necessary and flushes all buffered data to the
underlying I/O stream. If you want to explicitly specify the end of a data
chunk for some reason, you can write `TranscodingStreams.TOKEN_END` to the
transcoding stream, which finishes the current transcoding process without
closing the underlying stream:
```julia
using CodecZstd
using TranscodingStreams
buf = IOBuffer()
stream = ZstdCompressorStream(buf)
write(stream, "foobarbaz"^100, TranscodingStreams.TOKEN_END)
flush(stream)
compressed = take!(buf)
close(stream)
```

Use a noop codec
----------------

The `Noop` codec does nothing (i.e., buffering data without transformation).
`NoopStream` is an alias of `TranscodingStream{Noop}`.  The following example
creates a decompressor stream based on the extension of a filepath:
```julia
using CodecZlib
using CodecXz
using TranscodingStreams

function makestream(filepath)
    if endswith(filepath, ".gz")
        codec = GzipDecompressor()
    elseif endswith(filepath, ".xz")
        codec = XzDecompressor()
    else
        codec = Noop()
    end
    return TranscodingStream(codec, open(filepath))
end

makestream("data.txt.gz")
makestream("data.txt.xz")
makestream("data.txt")
```

Change the codec of a file
--------------------------

`TranscodingStream`s are composable: a stream can be an input/output of another
stream. You can use this to change the format of a file by composing different
codecs as below:
```julia
using CodecZlib
using CodecZstd

input  = open("data.txt.gz",  "r")
output = open("data.txt.zst", "w")

stream = GzipDecompressorStream(ZstdCompressorStream(output))
write(stream, input)
close(stream)
```

Effectively, this is equivalent to the following pipeline:

    cat data.txt.gz | gzip -d | zstd >data.txt.zst

Stop decoding on the end of a block
-----------------------------------

Many codecs support decoding concatenated data blocks (or chunks). For example,
if you concatenate two gzip files into a single file and read it using
`GzipDecompressorStream`, you will see the byte stream of concatenation of the
two files. If you need the part corresponding the first file, you can set
`stop_on_end` to `true` to stop transcoding at the end of the first block.
Note that setting `stop_on_end` to `true` does not close the wrapped stream
because you will often want to reuse it.
```julia
using CodecZlib
# cat foo.txt.gz bar.txt.gz > foobar.txt.gz
stream = GzipDecompressorStream(open("foobar.txt.gz"), stop_on_end=true)
read(stream)  #> the content of foo.txt
eof(stream)   #> true
```

In the case where you need to reuse the wrapped stream, the code above must be
slightly modified because the transcoding stream may read more bytes than
necessary from the wrapped stream. Wrapping the stream with `NoopStream` solves
the problem because any extra data read after the end of the chunk will be 
stored back in the internal buffer of the wrapped transcoding stream.
```julia
using CodecZlib
using TranscodingStreams
stream = NoopStream(open("foobar.txt.gz"))
read(GzipDecompressorStream(stream, stop_on_end=true))  #> the content of foo.txt
read(GzipDecompressorStream(stream, stop_on_end=true))  #> the content of bar.txt
```

Check I/O statistics
--------------------

`TranscodingStreams.stats` returns a snapshot of the I/O statistics. For
example, the following function shows progress of decompression to the standard
error:
```julia
using CodecZlib

function decompress(input, output)
    buffer = Vector{UInt8}(undef, 16 * 1024)
    GC.@preserve buffer while !eof(input)
        n = min(bytesavailable(input), length(buffer))
        unsafe_read(input, pointer(buffer), n)
        unsafe_write(output, pointer(buffer), n)
        stats = TranscodingStreams.stats(input)
        print(STDERR, "\rin: $(stats.in), out: $(stats.out)")
    end
    println(STDERR)
end

input = GzipDecompressorStream(open("foobar.txt.gz"))
output = IOBuffer()
decompress(input, output)
```

`stats.in` is the number of bytes supplied to the stream and `stats.out` is the
number of bytes consumed out of the stream.

Transcode data in one shot
--------------------------

TranscodingStreams.jl extends the `transcode` function to transcode a data
in one shot. `transcode` takes a codec object as its first argument and a data
vector as its second argument:
```julia
using CodecZlib
decompressed = transcode(ZlibDecompressor, b"x\x9cKL*JLNLI\x04R\x00\x19\xf2\x04U")
String(decompressed)
```

Transcode lots of strings
-------------------------

`transcode(<codec type>, data)` method is convenient but suboptimal when
transcoding a number of objects. This is because the method reallocates a new
codec object for every call. Instead, you can use `transcode(<codec object>,
data)` method that reuses the allocated object as follows. In this usage, you
need to explicitly allocate and free resources by calling
`TranscodingStreams.initialize` and `TranscodingStreams.finalize`,
respectively.

```julia
using CodecZstd
using TranscodingStreams
strings = ["foo", "bar", "baz"]
codec = ZstdCompressor()
TranscodingStreams.initialize(codec)  # allocate resources
try
    for s in strings
        data = transcode(codec, s)
        # do something...
    end
catch
    rethrow()
finally
    TranscodingStreams.finalize(codec)  # free resources
end
```

Unread data
-----------

`TranscodingStream` supports *unread* operation, which inserts data into the
current reading position. This is useful when you want to peek from the stream.
`TranscodingStreams.unread` and `TranscodingStreams.unsafe_unread` functions are
provided:
```julia
using TranscodingStreams
stream = NoopStream(open("data.txt"))
data1 = read(stream, 8)
TranscodingStreams.unread(stream, data1)
data2 = read(stream, 8)
@assert data1 == data2
```

The unread operation is different from the write operation in that the unreaded
data are not written to the wrapped stream. The unreaded data are stored in the
internal buffer of a transcoding stream.

Unfortunately, *unwrite* operation is not provided because there is no way to
cancel write operations that are already committed to the wrapped stream.

Developer's notes
=================

These notes are not for end users but rather for developers who are interested
in the design of the package.


`TranscodingStream` type
------------------------

`TranscodingStream{C,S}` (defined in src/stream.jl) has three fields:
- `codec`: data codec (`<:C where C<:Codec`)
- `stream`: data stream (`<:S where S<:IO`)
- `state`: current state (`<:State`).

A codec will be implemented by package developers and only a special codec
`Noop` is defined in this package.  A stream can be any object that implements
at least `Base.isopen`, `Base.eof`, `Base.close`, `Base.bytesavailable`,
`Base.unsafe_read`, and `Base.unsafe_write`.  All mutable fields are delegated
to `state` and hence the stream type itself is immutable.

A stream has two buffers in the `state` field. These are used to store
pre-transcoded and transcoded data in the stream. The stream passes references
of these two buffers to the codec when processing data. The following diagram
illustrates the flow of data:

    When reading data (`state.mode == :read`):
      user <--- |state.buffer1| <--- <stream.codec> <--- |state.buffer2| <--- stream

    When writing data (`state.mode == :write`):
      user ---> |state.buffer1| ---> <stream.codec> ---> |state.buffer2| ---> stream

In the read mode, a user pull out data from `state.buffer1` and pre-transcoded
data are filled in `state.buffer2`. In the write mode, a user will push data
into `state.buffer1` and transcoded data are filled in `state.buffer2`. The
default buffer size is 16KiB for each.

`State` (defined in src/state.jl) has five fields:
- `mode`: current stream mode (`<:Symbol`)
- `code`: return code of the last codec's method call (`<:Symbol`)
- `error`: exception returned by the codec (`<:Error`)
- `buffer1`: data buffer that is closer to the user (`<:Buffer`)
- `buffer2`: data buffer that is farther to the user (`<:Buffer`)
- `bytes_written_out`: number of bytes written to the underlying stream (`<:Int64`)

The `mode` field may be one of the following value:
- `:idle` : initial and intermediate mode, no buffered data
- `:read` : being ready to read data, data may be buffered
- `:write`: being ready to write data, data may be buffered
- `:stop` : transcoding is stopped after read, data may be buffered
- `:close`: closed, no buffered data
- `:panic`: an exception has been thrown in codec, data may be buffered but we
            cannot do anything

Note that `mode=:stop` does not mean there is no data available in the stream.
This is because transcoded data may be left in the buffer.

The initial mode is `:idle` and mode transition happens as shown in the
following diagram:
![Mode transition](./assets/modes.svg)

Modes surrounded by a bold circle are a state in which the transcoding stream
has released resources by calling `finalize(codec)`.  The mode transition should
happen in the `changemode!(stream, newmode)` function in src/stream.jl. Trying
an undefined transition will thrown an exception.

A transition happens according to internal or external events of the transcoding
stream. The status code and the error object returned by codec methods are
internal events, and user's method calls are external events.  For example,
calling `read(stream)` will change the mode from `:init` to `:read` and then
calling `close(stream)` will change the mode from `:read` to `:close`. When data
processing fails in the codec, a codec will return `:error` and the stream will
result in `:panic`.


Shared buffers
--------------

Adjacent transcoding streams may share their buffers. This will reduce memory
allocation and eliminate data copy between buffers.

If `buffer2` is shared it is considered to be owned by the underlying stream 
by the `stats` and `position` functions.

`readdata!(input::IO, output::Buffer)` and `flush_buffer2(stream::TranscodingStream)` do the actual work of read/write data from/to the underlying
stream. These methods have a special pass for shared buffers.


`Noop` codec
------------

`Noop` (`NoopStream`) is a codec that does *nothing*. It works as a buffering
layer on top of the underlying stream. Since `NoopStream` does not need to have
two distinct buffers, `buffer1` and `buffer2` in the `State` object are shared
and some specialized methods are defined for the type. All of these are defined
in src/noop.jl.

# Home

![TranscodingStream](./assets/transcodingstream.png)

## Overview

TranscodingStreams.jl is a package for transcoding data streams. Transcoding
may be compression, decompression, ASCII encoding, and any other codec.  The
package exports a data type `TranscodingStream`, which is a subtype of `IO` and
wraps other `IO` object to transcode data read from or written to the wrapped
stream.

In this page, we introduce the basic concepts of TranscodingStreams.jl and
currently available packages. The [Examples](@ref) page demonstrates common
usage. The [Reference](@ref) page offers a comprehensive API document.

## Introduction

`TranscodingStream` has two type parameters, `C<:Codec` and `S<:IO`, and hence
the concrete data type is written as `TranscodingStream{C<:Codec,S<:IO}`. This
type wraps an underlying I/O stream `S` by a transcoding codec `C`. `C` and `S`
are orthogonal and hence you can use any combination of these two types.  The
underlying stream may be any stream that supports I/O operations defined by the
`Base` module. For example, it may be `IOStream`, `TTY`, `IOBuffer`, or
`TranscodingStream`. The codec `C` must define the transcoding protocol defined
in this package.  We already have various codecs in packages listed below.  Of
course, you can define your own codec by implementing the transcoding protocol
described in [`TranscodingStreams.Codec`](@ref).

You can install codec packages using the standard package manager. These codec
packages are independent of each other and can be installed separately. You
won't need to explicitly install the TranscodingStreams.jl package unless you
will use lower-level interfaces of it. Each codec package defines some codec
types, which is a subtype of `TranscodingStreams.Codec`, and their
corresponding transcoding stream aliases.  These aliases are partially
instantiated by a codec type; for example, `GzipDecompressionStream{S}` is an
alias of `TranscodingStream{GzipDecompressor,S}`, where `S` is a subtype of
`IO`.

```@raw html
<table>
    <tr>
        <th>Package</th>
        <th>Library</th>
        <th>Format</th>
        <th>Codec</th>
        <th>Stream alias</th>
        <th>Description</th>
    </tr>
    <tr>
        <td rowspan="6"><a href="https://github.com/bicycle1885/CodecZlib.jl">CodecZlib.jl</a></td>
        <td rowspan="6"><a href="http://zlib.net/">zlib</a></td>
        <td rowspan="2"><a href="https://tools.ietf.org/html/rfc1952">RFC1952</a></td>
        <td><code>GzipCompressor</code></td>
        <td><code>GzipCompressorStream</code></td>
        <td>Compress data in gzip (.gz) format.</td>
    </tr>
    <tr>
        <td><code>GzipDecompressor</code></td>
        <td><code>GzipDecompressorStream</code></td>
        <td>Decompress data in gzip (.gz) format.</td>
    </tr>
    <tr>
        <td rowspan="2"><a href="https://tools.ietf.org/html/rfc1950">RFC1950</a></td>
        <td><code>ZlibCompressor</code></td>
        <td><code>ZlibCompressorStream</code></td>
        <td>Compress data in zlib format.</td>
    </tr>
    <tr>
        <td><code>ZlibDecompressor</code></td>
        <td><code>ZlibDecompressorStream</code></td>
        <td>Decompress data in zlib format.</td>
    </tr>
    <tr>
        <td rowspan="2"><a href="https://tools.ietf.org/html/rfc1951">RFC1951</a></td>
        <td><code>DeflateCompressor</code></td>
        <td><code>DeflateCompressorStream</code></td>
        <td>Compress data in deflate format.</td>
    </tr>
    <tr>
        <td><code>DeflateDecompressor</code></td>
        <td><code>DeflateDecompressorStream</code></td>
        <td>Decompress data in deflate format.</td>
    </tr>
    <tr>
        <td rowspan="2"><a href="https://github.com/bicycle1885/CodecXz.jl">CodecXz.jl</a></td>
        <td rowspan="2"><a href="https://tukaani.org/xz/">xz</a></td>
        <td rowspan="2"><a href="https://tukaani.org/xz/xz-file-format.txt">The .xz File Format</a></td>
        <td><code>XzCompressor</code></td>
        <td><code>XzCompressorStream</code></td>
        <td>Compress data in xz (.xz) format.</td>
    </tr>
    <tr>
        <td><code>XzDecompressor</code></td>
        <td><code>XzDecompressorStream</code></td>
        <td>Decompress data in xz (.xz) format.</td>
    </tr>
    <tr>
        <td rowspan="2"><a href="https://github.com/bicycle1885/CodecZstd.jl">CodecZstd.jl</a></td>
        <td rowspan="2"><a href="http://facebook.github.io/zstd/">zstd</a></td>
        <td rowspan="2"><a href="https://github.com/facebook/zstd/blob/dev/doc/zstd_compression_format.md">Zstandard Compression Format</a></td>
        <td><code>ZstdCompressor</code></td>
        <td><code>ZstdCompressorStream</code></td>
        <td>Compress data in zstd (.zst) format.</td>
    </tr>
    <tr>
        <td><code>ZstdDecompressor</code></td>
        <td><code>ZstdDecompressorStream</code></td>
        <td>Decompress data in zstd (.zst) format.</td>
    </tr>
    <tr>
        <td rowspan="6"><a href="https://github.com/bicycle1885/CodecBase.jl">CodecBase.jl</a></td>
        <td rowspan="6">native</td>
        <td rowspan="6"><a href="https://tools.ietf.org/html/rfc4648">RFC4648</a></td>
        <td><code>Base16Encoder</code></td>
        <td><code>Base16EncoderStream</code></td>
        <td>Encode binary in base16 format.</td>
    </tr>
    <tr>
        <td><code>Base16Decoder</code></td>
        <td><code>Base16DecoderStream</code></td>
        <td>Decode binary in base16 format.</td>
    </tr>
    <tr>
        <td><code>Base32Encoder</code></td>
        <td><code>Base32EncoderStream</code></td>
        <td>Encode binary in base32 format.</td>
    </tr>
    <tr>
        <td><code>Base32Decoder</code></td>
        <td><code>Base32DecoderStream</code></td>
        <td>Decode binary in base32 format.</td>
    </tr>
    <tr>
        <td><code>Base64Encoder</code></td>
        <td><code>Base64EncoderStream</code></td>
        <td>Encode binary in base64 format.</td>
    </tr>
    <tr>
        <td><code>Base64Decoder</code></td>
        <td><code>Base64DecoderStream</code></td>
        <td>Decode binary in base64 format.</td>
    </tr>
    <tr>
        <td rowspan="2"><a href="https://github.com/bicycle1885/CodecBzip2.jl">CodecBzip2.jl</a></td>
        <td rowspan="2"><a href="http://www.bzip.org/">bzip2</a></td>
        <td rowspan="2"></td>
        <td><code>Bzip2Compressor</code></td>
        <td><code>Bzip2CompressorStream</code></td>
        <td>Compress data in bzip2 (.bz2) format.</td>
    </tr>
    <tr>
        <td><code>Bzip2Decompressor</code></td>
        <td><code>Bzip2DecompressorStream</code></td>
        <td>Decompress data in bzip2 (.bz2) format.</td>
    </tr>
</table>
```


## Notes

### Wrapped streams

The wrapper stream takes care of the wrapped stream. Reading or writing data
from or to the wrapped stream outside the management will result in unexpected
behaviors. When you close the wrapped stream, you must call the `close` method
of the wrapper stream, which releases allocated resources and closes the
wrapped stream.

### Error handling

You may encounter an error while processing data with this package. For
example, your compressed data may be corrupted or truncated for some reason,
and the decompressor cannot recover the original data. In such a case, the
codec informs the stream of the error, and the stream goes to an unrecoverable
mode.  In this mode, the only possible operations are `isopen` and `close`.
Other operations, such as `read` or `write`, will result in an argument error
exception. Resources allocated by the codec will be released by the stream, and
hence you must not call the finalizer of the codec.

Migration
=========

How to migrate from v0.10 to v0.11
----------------------------------

v0.11 has a few subtle breaking changes to `eof` and `seekend`.

### `Memory(data::ByteData)`

The `Memory(data::ByteData)` constructor was removed.
Use `Memory(pointer(data), sizeof(data))` instead.

### `seekend(stream::TranscodingStream)`

Generic `seekend` for `TranscodingStream` was removed.
If the objective is to discard all remaining data in the stream, use `skip(stream, typemax(Int64))` instead where `typemax(Int64)` is meant to be a large number to exhaust the stream.
Ideally, specific implementations of `TranscodingStream` will implement `seekend` only if efficient means exist to avoid fully processing the stream.
`NoopStream` still supports `seekend`.

The previous behavior of the generic `seekend` was something like 
`(seekstart(stream); seekend(stream.stream); stream)` but this led to
inconsistencies with the position of the stream.

### `eof(stream::TranscodingStream)`

`eof` now throws an error if called on a stream that is closed or in writing mode.
Use `!isreadable(stream) || eof(stream)` if you need to more closely match previous behavior.
